
var SceneDialog = function()
{
    SceneDialog.instance = this;

    this.create();
};

SceneDialog.instance = null;

SceneDialog.prototype = {

    create: function ()
    {
        grpSceneDialog = game.add.group();
        grpSceneDialog.name = "grpSceneDialog";
        this.grpScene = grpSceneDialog;

        imgDialogOverlay = game.add.sprite(game.width >> 1, game.height >> 1, 'pak1', 'blank.png');
        imgDialogOverlay.anchor.setTo(0.5, 0.5);
        imgDialogOverlay.tint = 0x354854;
        imgDialogOverlay.alpha = 0.7;
        imgDialogOverlay.inputEnabled = true;
        grpSceneDialog.addChild(imgDialogOverlay);

        imgDialogGB = game.add.sprite((game.width >> 1), (game.height >> 1) * 0.7, 'pak1', 'dialogwindow.png');
        imgDialogGB.anchor.set(0.5);
        imgDialogGB.scale.set(0.7  * game.width / 680);
        grpSceneDialog.add(imgDialogGB);

        /*
        txtDialogText = gameState.CreateText(0, -imgDialogGB.height / 7 /imgDialogGB.scale.y, 'gamefont', STR('REDEAL_SWITCH_TEXT_DRAW_1'), 27);
        txtDialogText.anchor.setTo(0.5, 0.5);
        txtDialogText.align = 'center';
        txtDialogText.tint = 0xffffff;
        txtDialogText.str = 'REDEAL_SWITCH_TEXT_DRAW_1';
        imgDialogGB.addChild(txtDialogText);
        */

        imgDialogTitle = game.add.sprite(0, -imgDialogGB.height / 7 /imgDialogGB.scale.y, 'pak1', 'autocomplete.png');
        imgDialogTitle.anchor.setTo(0.5, 0.5);
        imgDialogTitle.tint = 0xffffff;
        imgDialogGB.addChild(imgDialogTitle);

        callbackDialogBtn1 = function(){};

        btnDialog1 = (gameState.CreateImgButtonWithText(grpSceneDialog, 'dialogbutton.png', STR('REDEAL_BUTTON_REDEAL'), callbackDialogBtn1, 0x3f94b6));
        imgDialogGB.addChild(btnDialog1);
        btnDialog1.scale.set(0.5);
        btnDialog1.str = 'REDEAL_BUTTON_REDEAL';
        btnDialog1.position.setTo(-imgDialogGB.width / 5.5 / imgDialogGB.scale.x, imgDialogGB.height / 7 * 1.7 / imgDialogGB.scale.y);
        btnDialog1.txtCaption.visible = false;

        callbackDialogBtn2 = function(){};

        btnDialog2 = (gameState.CreateImgButtonWithText(grpSceneDialog, 'dialogbutton.png', STR('REDEAL_BUTTON_CANCEL'), callbackDialogBtn2, 0x3f94b6));
        imgDialogGB.addChild(btnDialog2);
        btnDialog2.scale.set(0.5);
        btnDialog2.str = 'REDEAL_BUTTON_CANCEL';
        btnDialog2.position.setTo(imgDialogGB.width / 5.5 / imgDialogGB.scale.x, imgDialogGB.height / 7 * 1.7 / imgDialogGB.scale.y);
        btnDialog2.txtCaption.visible = false;

        grpSceneDialog.visible = false;
    },

    onResolutionChange: function()
    {
        imgDialogOverlay.width = game.width;
        imgDialogOverlay.height = game.height;
        imgDialogOverlay.position.setTo(game.width >> 1, game.height >> 1);

        imgDialogGB.position.setTo(game.width >> 1, game.height >> 1);
        imgDialogGB.width = game.width * 0.85;
        imgDialogGB.scale.y = imgDialogGB.scale.x;

        imgDialogTitle.width = imgDialogGB.width * 0.5 / imgDialogGB.scale.x;
        imgDialogTitle.scale.y = imgDialogTitle.scale.x;
        if(imgDialogTitle.height > imgDialogGB.height * 0.3 / imgDialogGB.scale.y){
            imgDialogTitle.height = imgDialogGB.height * 0.3 / imgDialogGB.scale.y;
            imgDialogTitle.scale.x = imgDialogTitle.scale.y;
        }

        btnDialog1.width = imgDialogGB.width * 0.3 / imgDialogGB.scale.x;
        btnDialog1.scale.y = btnDialog1.scale.x;

        btnDialog2.width = imgDialogGB.width * 0.3 / imgDialogGB.scale.x;
        btnDialog2.scale.y = btnDialog2.scale.x;
    },

    update: function()
    {
    },

    updateTexts: function()
    {
        /*
        txtDialogText.text = STR(txtDialogText.str);
        btnDialog1.txtCaption.text = STR(btnDialog1.str);
        btnDialog2.txtCaption.text = STR(btnDialog2.str);

        updateBitmapTextToWidth(txtDialogText, 27, imgDialogGB.width * 0.9);
        updateBitmapTextToWidth(btnDialog1.txtCaption, 35, btnDialog1.width * 0.5);
        updateBitmapTextToWidth(btnDialog2.txtCaption, 35, btnDialog2.width * 0.5);
        */
    },

    ShowAnimated: function (dialogTitleImg, button1Img, button2Img, button1callback, button2callback)
    {
        if(dialogTitleImg === undefined)
            dialogTitleImg = 'autocomplete.png';

        if(button1Img === undefined)
            button1Img = 'autoYES.png';

        if(button2Img === undefined)
            button2Img = 'autoNO.png';

        if(button1callback === undefined)
            button1callback = function(){
                soundManager.playSound('menu-click1');
                SceneDialog.instance.HideAnimated();
            };

        if(button2callback === undefined)
            button2callback = function(){
                soundManager.playSound('menu-click1');
                SceneDialog.instance.HideAnimated();
            };

        callbackDialogBtn1 = button1callback;
        callbackDialogBtn2 = button2callback;

        imgDialogGB.updateTransform(grpSceneDialog);

        imgDialogTitle.frameName = dialogTitleImg;

        btnDialog1.frameName = button1Img;
        btnDialog1.inputEnabled = false;
        AddButtonEvents(btnDialog1, callbackDialogBtn1, ButtonOnInputOver, ButtonOnInputOut);

        btnDialog2.frameName = button2Img;
        btnDialog2.inputEnabled = false;
        AddButtonEvents(btnDialog2, callbackDialogBtn2, ButtonOnInputOver, ButtonOnInputOut);

        SceneDialog.instance.onResolutionChange();

        //txtDialogText.str = dialogTextSTR;
        //btnDialog1.str = button1STR;
        //btnDialog2.str = button2STR;

        SceneDialog.instance.updateTexts();

        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
        ScenesTransitions.showSceneAlpha(grpSceneDialog, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;

        soundManager.playSound('dialog');
    },

    HideAnimated: function ()
    {
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
        ScenesTransitions.hideSceneAlpha(grpSceneDialog, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
    }

}