var DURATION_ZOOM_IN = ScenesTransitions.TRANSITION_LENGTH * 0.6;
var DURATION_BOUNCE_OUT = DURATION_ZOOM_IN * 1.5;

var CARD_SLOT_HOLDER = -1979;
var CARDS_DSPY = 28;

var DOUBLECLICK_DELAY = 300;

var DURATION_AUTO_PLACEMENT_MOVE_MULT = 16;
var DURATION_CARD_FLIP = 100;

var gameRunning = false;
var gamePaused = false;

var SceneGame = function()
{
    SceneGame.instance = this;

    this.create();
};

SceneGame.instance = null;

SceneGame.prototype = {

    create: function ()
    {
        scnGame = this;

        grpSceneGame = game.add.group();
        grpSceneGame.name = 'grpSceneGame';

        imgGameBG = game.add.sprite(game.width >> 1, game.height, GetSelectedBackground());
        imgGameBG.anchor.setTo(0.5, 1);
        grpSceneGame.addChild(imgGameBG);

        //region TOPBAR

        imgGameTopBar = game.add.sprite(game.width >> 1, 0, 'pak1', GetSelectedThemeTopBar());
        imgGameTopBar.anchor.setTo(0.5, 0.5);
        grpSceneGame.addChild(imgGameTopBar);

        imgGameTopBarAnchor = game.add.sprite(0, 0, 'pak1', 'void.png');
        imgGameTopBarAnchor.anchor.setTo(0.5, 0.5);
        imgGameTopBar.addChild(imgGameTopBarAnchor);

        //txtGameTime  = SceneGame.instance.CreateIngameTopBarCaption('Time');
        //txtGameMoves = SceneGame.instance.CreateIngameTopBarCaption('Moves');
        //txtGameScore = SceneGame.instance.CreateIngameTopBarCaption('Score');

        imgGameTime = game.add.sprite(0, 0, 'game', 'topbar_0.png');
        imgGameTime.anchor.setTo(0.5, 0.5);
        imgGameTopBarAnchor.addChild(imgGameTime);

        imgGameMoves = game.add.sprite(0, 0, 'game', 'topbar_1.png');
        imgGameMoves.anchor.setTo(0.5, 0.5);
        imgGameTopBarAnchor.addChild(imgGameMoves);

        imgGameScore = game.add.sprite(0, 0, 'game', 'topbar_2.png');
        imgGameScore.anchor.setTo(0.5, 0.5);
        imgGameTopBarAnchor.addChild(imgGameScore);

        txtGameTimeVal  = SceneGame.instance.CreateIngameTopBarValue('00:47');
        txtGameMovesVal = SceneGame.instance.CreateIngameTopBarValue('12');
        txtGameScoreVal = SceneGame.instance.CreateIngameTopBarValue('110');

        //endregion

        //region BOTTOM BUTTONS

        ingameButtons = [];
        ingameButtons.push(this.CreateIngameButton('ingamenav_1.png', function(){
            if(animatingFlip || animatingSlot)
                return;

            gameRunning = false;
            soundManager.playSound('menu-click1');
            SceneMenu.instance.onResolutionChange();
            ScenePause.instance.ShowAnimated();
            SceneMenu.instance.ShowAnimated();
            SceneMenu.instance.SelectMenuButtonAnimated(btnMenuButtons[0]);
        }));
        ingameButtons.push(this.CreateIngameButton('ingamenav_2.png', scnGame.OnPressedIngameHint));
        ingameButtons.push(this.CreateIngameButton('ingamenav_3.png', scnGame.OnPressedIngameUndo));
        ingameButtons.push(this.CreateIngameButton('ingamenav_4.png', function(){
            scnGame.PauseGame();
            //scnGame.GameOver();

            //SceneAutocomplete.instance.onResolutionChange();
            //ScenesTransitions.showSceneAlpha(grpAutocomplete, 0, ScenesTransitions.TRANSITION_LENGTH);

            /*
            snd_counter = 0;
            a = 10;
            a.a = 10;
            var twn = game.add.tween(a).to( {a: 100}, 50, Phaser.Easing.Back.InOut, true, 10, 1000, true);
            twn.onRepeat.add(function(){
                snd_counter ++;
                LOG('snd_counter = ' + snd_counter);
                var b = snd_counter % 2;
                switch(b){
                    case 0:
                        //soundManager.playSound('card');
                        scnGame.GetNextCardFromPack();
                        return;
                    case 1:
                        //soundManager.playSound('nomove');
                        scnGame.OnPressedIngameHint();
                        return;
                }
            });
            */

        }));

        //endregion

        //region CARDS

        var leftPos = game.width / 2;
        var topPos = game.height / 10;

        cardHolder = [];
        grpColorSlots = [];
        maxCardOfColor = [];

        for (var i = 0; i < 4; i++) {
            cardHolder[i] = grpSceneGame.create(leftPos + i * 63, topPos, 'game', 'nenieso.png');
            cardHolder[i].anchor.set(0.5);

            grpColorSlots[i] = game.add.group();
            grpColorSlots[i].x = leftPos + i * 63;
            grpColorSlots[i].y = topPos;
            grpColorSlots[i].name = "grpColorSlots" + i;
            grpColorSlots[i].cardColour = i;
            grpSceneGame.add(grpColorSlots[i]);

            maxCardOfColor[i] = 0;
        }

        leftPos = game.width / 2 - 186;

        sprCardPack = grpSceneGame.create(leftPos, topPos, 'game', GetCardBackFrame());
        sprCardPack.anchor.set(0.5);
        sprCardPack.name = "sprCardPack";
        sprCardPack.inputEnabled = true;
        sprCardPack.events.onInputDown.add(this.GetNextCardFromPack, false);

        grpCardFromPack = game.add.group();
        //grpCardFromPack = grpSceneGame.create(0, 0, 'pak1', 'void.png');
        grpCardFromPack.name = 'grpCardFromPack';
        grpSceneGame.add(grpCardFromPack);

        topPos = 240;

        grpCardSlots = [];

        for (var i = 0; i < 7; i++) {
            grpCardSlots[i] = game.add.group();
            grpCardSlots[i].x = leftPos + i * 63;
            grpCardSlots[i].y = topPos;
            grpCardSlots[i].name = "grpCardSlots" + i;
            grpSceneGame.add(grpCardSlots[i]);
        }

        cardSlotMoving = game.add.group();
        cardSlotMoving.name = "cardSlotMoving";
        game.physics.arcade.enable(cardSlotMoving);
        animatingFlip = false;
        animatingSlot = false;
        grpSceneGame.add(cardSlotMoving);

        sprCardsFromPack = [];
        sprCardFromPack = null;
        sprTintedCard = null;

        cardDragStopEvents = [];

        //endregion

        gameRunning = false;
        grpSceneGame.visible = false;

        if(GameData.profile.savedGame != null){
            scnGame.RestoreSavedGame();
            grpSceneGame.visible = true;
        }
    },

    onBackKeyDown: function()
    {
        if(!grpSceneGame.visible)
            return false;
        if(!gameRunning)
            return false;
        if(ScenesTransitions.transitionActive)
            return false;
        if(grpAutocomplete.visible)
            return false;
        if(grpSceneDialog.visible)
            return false;

        scnGame.PauseGame();
        return true;
    },

    CreateIngameTopBarCaption: function(str)
    {
        var txtIngameCaption = gameState.CreateText(0, 0, 'gamefont', str, 35);
        txtIngameCaption.anchor.setTo(0.5, 0.5);
        txtIngameCaption.tint = 0xffff00;
        imgGameTopBarAnchor.addChild(txtIngameCaption);

        return txtIngameCaption;
    },

    CreateIngameTopBarValue: function(str)
    {
        var txtIngameVal = gameState.CreateText(0, 0, 'gamefont', str, 25  * game.width / 680);
        txtIngameVal.anchor.setTo(0.5, 0.5);
        txtIngameVal.tint = 0xffffff;
        imgGameTopBarAnchor.addChild(txtIngameVal);

        return txtIngameVal;
    },

    CreateIngameButton: function(icon, callback)
    {
        var ingameButton = grpSceneGame.create(0, 0, 'pak1', GetSelectedIngameButton());
        ingameButton.anchor.set(0.5);

        var imgIcon = grpSceneGame.create(0, 0, 'pak1', icon);
        imgIcon.anchor.set(0.5);
        imgIcon.scale.set(0.5);
        ingameButton.addChild(imgIcon);

        ingameButton.imgIcon = imgIcon;

        AddButtonEvents(ingameButton, callback, ButtonOnInputOver, ButtonOnInputOut);

        return ingameButton;
    },

    onResolutionChange: function()
    {
        imgGameTime.tint = GetSelectedThemeTopBarFontCol();
        imgGameMoves.tint = GetSelectedThemeTopBarFontCol();
        imgGameScore.tint = GetSelectedThemeTopBarFontCol();

        imgGameBG.loadTexture(GetSelectedBackground());

        var itemGap = 15;
        var itemH = game.height / 8;

        imgGameTopBar.frameName = GetSelectedThemeTopBar();
        imgGameTopBar.width = game.width;
        imgGameTopBar.height = itemH;
        imgGameTopBar.position.setTo(game.width >> 1, itemH >> 1);

        imgGameTopBarAnchor.scale.setTo(1 / imgGameTopBar.scale.x, 1 / imgGameTopBar.scale.y);

        imgGameTime.x  = -game.width >> 2;
        imgGameTime.y  = -itemH * 0.2;
        imgGameScore.x =  game.width >> 2;
        imgGameScore.y  = -itemH * 0.2;
        imgGameMoves.y  = -itemH * 0.2;

        txtGameTimeVal.x  = -game.width >> 2;
        txtGameTimeVal.y  = itemH * 0.1;
        txtGameScoreVal.x =  game.width >> 2;
        txtGameScoreVal.y  = itemH * 0.1;
        txtGameMovesVal.y  = itemH * 0.1;

        imgGameBG.width = game.width;
        imgGameBG.scale.y = imgGameBG.scale.x;
        imgGameBG.position.setTo(game.width >> 1, game.height);

        var btnW = game.width / 4.4;

        var posX = (game.width >> 1) - btnW * 1.5;
        for(var i = 0; i < ingameButtons.length; i++){
            ingameButtons[i].frameName = GetSelectedIngameButton();
            ingameButtons[i].width = btnW * 0.8;
            ingameButtons[i].scale.y = ingameButtons[i].scale.x;
            ingameButtons[i].position.x = posX;
            ingameButtons[i].position.y = game.height - btnW * 0.6;
            posX += btnW;
        }

        //region CARDS

        var cardW = game.width / 7.5;
        for (var i = 0; i < 7; i++){
            grpCardSlots[i].scale.set(game.width / 680 * 0.7);
            grpCardSlots[i].x = cardW * 0.75 + cardW * i;
        }

        sprCardPack.scale.set(game.width / 680 * 0.7);
        sprCardPack.x = GameData.profile.RightHanded ? grpCardSlots[0].x : grpCardSlots[6].x;
        sprCardPack.y = sprCardPack.height * 2;

        grpCardFromPack.scale.set(game.width / 680 * 0.7);
        grpCardFromPack.x = GameData.profile.RightHanded ? grpCardSlots[1].x : (GameData.profile.Draw1 ? grpCardSlots[5].x : grpCardSlots[4].x);
        grpCardFromPack.y = sprCardPack.height * 2;
        grpCardFromPack.X = grpCardFromPack.x;
        grpCardFromPack.Y = grpCardFromPack.y;

        for (var i = 0; i < 4; i++) {
            cardHolder[i].scale.set(game.width / 680 * 0.7);
            cardHolder[i].x = grpCardSlots[(GameData.profile.RightHanded ? 3 : 0) + i].x;
            cardHolder[i].y = sprCardPack.height * 2;

            grpColorSlots[i].scale.set(game.width / 680 * 0.7);
            grpColorSlots[i].x = grpCardSlots[(GameData.profile.RightHanded ? 3 : 0) + i].x;
            grpColorSlots[i].y = sprCardPack.height * 2;
        }

        for (var i = 0; i < 7; i++){
            grpCardSlots[i].y = sprCardPack.height * 3.5;
        }

        cardSlotMoving.scale.set(game.width / 680 * 0.7);

        //enndregion

    },

    update: function()
    {
        if(!gameRunning)
            return;

        scnGame.updateCardDragStopEvents();

        gameTimer += game.time.physicsElapsedMS;

        scnGame.SetTimerText(txtGameTimeVal, gameTimer);

        if(!game.input.activePointer.leftButton.isDown && !game.input.pointer1.isDown)
            return;

        scnGame.updateMovingSlot();
    },

    updateCardDragStopEvents: function()
    {
        if(cardDragStopEvents.length == 0)
            return;

        for(var i = 0; i < cardDragStopEvents.length; i++){
            cardDragStopEvents[i].time -= game.time.physicsElapsedMS;
            if(cardDragStopEvents[i].time <= 0)
                scnGame.cardStopDrag(cardDragStopEvents[i].card);
        }

    },

    onPause: function()
    {
        if(!grpSceneGame.visible)
            return;
        if(!gameRunning)
            return;
        if(ScenesTransitions.transitionActive)
            return;
        if(grpAutocomplete.visible)
            return;
        if(grpSceneDialog.visible)
            return;

        scnGame.PauseGame();
    },

    PauseGame: function()
    {
        gameRunning = false;
        soundManager.playSound('menu-click1');
        SceneMenu.instance.onResolutionChange();
        ScenePause.instance.ShowAnimated();
        SceneMenu.instance.ShowAnimated();
    },

    SetTimerText: function(txtObj, time)
    {
        time = Math.floor(time / 10);
        hundreds = time % 100;
        time = (time - hundreds) / 100;
        secs = time % 60;
        time = (time - secs) / 60;

        //txtObj.text = ((time <= 9) ? "0" : "") + time + ":" + ((secs <= 9) ? "0" : "") + secs;
        txtObj.text = time + ":" + ((secs <= 9) ? "0" : "") + secs;
    },

    updateTexts: function()
    {
        /*
        txtGameTime.text = STR('TIME').toUpperCase();
        txtGameMoves.text = STR('MOVES').toUpperCase();
        txtGameScore.text = STR('SCORE').toUpperCase();

        updateBitmapTextToWidth(txtGameTime, 25 * game.width / 680, game.width * 0.22);
        updateBitmapTextToWidth(txtGameMoves, 25 * game.width / 680, game.width * 0.22);
        updateBitmapTextToWidth(txtGameScore, 25 * game.width / 680, game.width * 0.22);


        var fontSize = txtGameTime.fontSize;
        if(txtGameMoves.fontSize < fontSize)
            fontSize = txtGameMoves.fontSize;
        if(txtGameScore.fontSize < fontSize)
            fontSize = txtGameScore.fontSize;

        txtGameTime.fontSize = fontSize;
        txtGameMoves.fontSize = fontSize;
        txtGameScore.fontSize = fontSize;
        */
    },

    //region GAME LOGIC

    GetNextCardFromPack: function(originated)
    {
        if(GameData.profile.Draw1){
            scnGame.GetNext1CardFromPack(originated);
            return;
        }

        scnGame.GetNext3CardsFromPack(originated);
    },

    GetNext1CardFromPack: function(auto)
    {
        if(animatingFlip || animatingSlot)
            return;

        if(cardSlotMoving.length > 0)
            return;

        LOG("GetNextCardFromPack() " + cardPackNumbers.length);

        if(auto == true){
            var tmpW = Math.floor(game.width / 7.5);

            sprCardsFromPack = [];
            if(grpCardFromPack.children.length == 0)
                return;

            sprCardsFromPack.push(grpCardFromPack.children[grpCardFromPack.children.length - 1]);

            for(var i = 0; i < sprCardsFromPack.length; i++){
                sprCardsFromPack[i].visible = true;

                var posTween = game.add.tween(sprCardsFromPack[i]);
                posTween.to( { x: i * tmpW / 2}, DURATION_CARD_FLIP, "Linear", 0);
                posTween.start();

                if( i == sprCardsFromPack.length - 1){
                    sprCardsFromPack[i].inputEnabled = true;
                    sprCardsFromPack[i].events.onInputDown.add(scnGame.cardStartDrag, this);
                    sprCardsFromPack[i].events.onInputUp.add(scnGame.cardStopDrag, this);
                    sprCardsFromPack[i].secondClick = false;
                }
            }
            soundManager.playSound('card');
            return;
        }

        if(cardPackNumbers.length == 0){
            if(grpCardFromPack.length == 0)
                return;

            cardFrame = grpCardFromPack.children[grpCardFromPack.length - 1].cardFrame;

            sprCardFromPack = grpSceneGame.create(grpCardFromPack.x, grpCardFromPack.y, 'game', GetCardFrame(cardFrame));
            sprCardFromPack.visible = false;
            sprCardFromPack.anchor.set(0.5);
            sprCardFromPack.cardFrame = cardFrame;
            sprCardFromPack.inputEnabled = true;
            sprCardFromPack.events.onInputDown.add(scnGame.cardStartDrag, this);
            sprCardFromPack.events.onInputUp.add(scnGame.cardStopDrag, this);
            sprCardFromPack.secondClick = false;
            sprCardFromPack.x = grpCardFromPack.x;
            sprCardFromPack.y = grpCardFromPack.y;
            sprCardFromPack.scale.set(game.width / 680 * 0.7);

            animatingFlip = true;
            var posTween = game.add.tween(sprCardFromPack);
            posTween.to( { x: sprCardPack.x + (grpCardFromPack.x - sprCardPack.x) / 2}, DURATION_CARD_FLIP, "Linear", false);

            posTween.start();

            var flipTween = game.add.tween(sprCardFromPack.scale);
            flipTween.to( { x: 0.05 * game.width / 680}, DURATION_CARD_FLIP, "Linear", false);
            posTween.onComplete.add(scnGame.onPackCardFlippedBack, {sprCard:sprCardFromPack, destX:sprCardPack.x});
            posTween.onStart.add(function(){
                this.sprCard.visible = true;
            }, {sprCard:sprCardFromPack});
            flipTween.start();

            while(grpCardFromPack.length > 0){
                var card = grpCardFromPack.children[grpCardFromPack.length - 1];
                cardPackNumbers.push(card.cardFrame);
                grpCardFromPack.remove(card);
                card.kill();
            }

            wasteRecycles ++;
            if(wasteRecycles > 1)
                scnGame.IncScore(-100, false);

            soundManager.playSound('card');
            return;
        }

        if((cardPackNumbers.length == 0) && (grpCardFromPack.children.length > 0)){
            cardFrame = grpCardFromPack.children[0].cardFrame;
            grpCardFromPack.remove(grpCardFromPack.children[0]);
        }

        if(cardPackNumbers.length > 0)
            cardFrame = cardPackNumbers.pop();

        sprCardFromPack = grpSceneGame.create(0, 0, 'game', GetCardBackFrame());
        sprCardFromPack.visible = false;
        sprCardFromPack.anchor.set(0.5);
        grpCardFromPack.addChild(sprCardFromPack);

        if((cardPackNumbers.length == 0) && (grpCardFromPack.children.length == 1))
            sprCardPack.frameName = 'norecycle.png';

        LOG("A: " + cardPackNumbers.length + " B: " + grpCardFromPack.children.length);

        sprCardFromPack.frameName = GetCardBackFrame();

        sprCardFromPack.cardFrame = cardFrame;
        sprCardFromPack.inputEnabled = true;
        sprCardFromPack.events.onInputDown.add(scnGame.cardStartDrag, this);
        sprCardFromPack.events.onInputUp.add(scnGame.cardStopDrag, this);
        sprCardFromPack.secondClick = false;
        sprCardFromPack.x = sprCardPack.x - grpCardFromPack.x + (sprCardFromPack.width / 2 * (GameData.profile.RightHanded ? -1 : 1));

        animatingFlip = true;
        var posTween = game.add.tween(sprCardFromPack);
        posTween.to( { x: sprCardFromPack.x / 2}, DURATION_CARD_FLIP, "Linear", false);
        posTween.start();

        var flipTween = game.add.tween(sprCardFromPack.scale);
        flipTween.to( { x: 0.05 * game.width / 680}, DURATION_CARD_FLIP, "Linear", false);
        posTween.onComplete.add(scnGame.onPackCardFlipped, {sprCard:sprCardFromPack, destX:0});
        posTween.onStart.add(function(){
            this.sprCard.visible = true;
        }, {sprCard:sprCardFromPack});
        flipTween.start();

        if(cardPackNumbers.length == 0){
            sprCardPack.frameName = 'neniwaste.png';
            if(grpCardFromPack.length == 0)
                sprCardPack.frameName = 'norecycle.png';
        }

    },

    ReloadCardBacks: function()
    {
        if(scnGame.IsCardBack(sprCardPack))
            sprCardPack.frameName = GetCardBackFrame();

        for(var i = 0; i < grpCardSlots.length; i++)
            for(var j = 1; j < grpCardSlots[i].length; j++){
                if(!scnGame.IsCardBack(grpCardSlots[i].children[j]))
                    continue;

                grpCardSlots[i].children[j].frameName = GetCardBackFrame();
            }
    },

    ReloadCardFaces: function()
    {
        for(var i = 0; i < grpCardSlots.length; i++)
            for(var j = 1; j < grpCardSlots[i].length; j++){
                if(scnGame.IsCardBack(grpCardSlots[i].children[j]))
                    continue;

                grpCardSlots[i].children[j].frameName = GetCardFrame(grpCardSlots[i].children[j].cardFrame);
            }

        for(var i = 0; i < grpColorSlots.length; i++)
            for(var j = 0; j < grpColorSlots[i].length; j++)
                grpColorSlots[i].children[j].frameName = GetCardFrame(grpColorSlots[i].children[j].cardFrame);

        for(var i = 0; i < grpCardFromPack.children.length; i++)
            grpCardFromPack.children[i].frameName = GetCardFrame(grpCardFromPack.children[i].cardFrame);

    },

    GetNext3CardsFromPack: function(auto)
    {
        if(animatingFlip || animatingSlot)
            return;

        if(cardSlotMoving.length > 0)
            return;

        if(auto == true){
            var tmpW = Math.floor(game.width / 7.5);

            sprCardsFromPack = [];
            for(var i = grpCardFromPack.children.length - 3; i <= grpCardFromPack.children.length - 1; i++){
                if(i >= 0)
                    sprCardsFromPack.push(grpCardFromPack.children[i]);
            }

            scnGame.showAllCardsTakenFromPack();

        /*
            for(var i = 0; i < sprCardsFromPack.length; i++){
                sprCardsFromPack[i].visible = true;

                var posTween = game.add.tween(sprCardsFromPack[i]);
                posTween.to( { x: i * tmpW / 2 * (GameData.profile.RightHanded ? 1 : -1)}, DURATION_CARD_FLIP, "Linear", 0);
                posTween.start();

                if( i == sprCardsFromPack.length - 1){
                    sprCardsFromPack[i].inputEnabled = true;
                    sprCardsFromPack[i].events.onInputDown.add(scnGame.cardStartDrag, this);
                    sprCardsFromPack[i].events.onInputUp.add(scnGame.cardStopDrag, this);
                    sprCardsFromPack[i].secondClick = false;
                }
            }

            */
            return;
        }

        for(var i = 0; i < grpCardFromPack.children.length; i++){
            grpCardFromPack.children[i].x = 0;
            grpCardFromPack.children[i].inputEnabled = false;
        }

        LOG("GetNextCardFromPack() " + cardPackNumbers.length);

        if(cardPackNumbers.length == 0){
            if(grpCardFromPack.length == 0)
                return;

            cardFrame = grpCardFromPack.children[grpCardFromPack.length - 1].cardFrame;

            sprCardFromPack = grpSceneGame.create(0, 0, 'game', GetCardFrame(cardFrame));
            sprCardFromPack.visible = false;
            sprCardFromPack.anchor.set(0.5);
            sprCardFromPack.cardFrame = cardFrame;
            sprCardFromPack.inputEnabled = true;
            sprCardFromPack.events.onInputDown.add(scnGame.cardStartDrag, this);
            sprCardFromPack.events.onInputUp.add(scnGame.cardStopDrag, this);
            sprCardFromPack.secondClick = false;
            sprCardFromPack.x = grpCardFromPack.x;
            sprCardFromPack.y = grpCardFromPack.y;
            sprCardFromPack.scale.set(game.width / 680 * 0.7);

            animatingFlip = true;
            var posTween = game.add.tween(sprCardFromPack);
            posTween.to( { x: sprCardPack.x + (grpCardFromPack.x - sprCardPack.x) / 2}, DURATION_CARD_FLIP, "Linear", false);
            posTween.start();

            var flipTween = game.add.tween(sprCardFromPack.scale);
            flipTween.to( { x: 0.05 * game.width / 680}, DURATION_CARD_FLIP, "Linear", false);
            posTween.onComplete.add(scnGame.onPackCardFlippedBack, {sprCard:sprCardFromPack, destX:sprCardPack.x});
            posTween.onStart.add(function(){
                this.sprCard.visible = true;
            }, {sprCard:sprCardFromPack});
            flipTween.start();

            while(grpCardFromPack.length > 0){
                var card = grpCardFromPack.children[grpCardFromPack.length - 1];
                cardPackNumbers.push(card.cardFrame);
                grpCardFromPack.remove(card);
                card.kill();
            }

            wasteRecycles ++;
            if(wasteRecycles > 3)
                scnGame.IncScore(-20, false);

            return;
        }


        if((cardPackNumbers.length == 0) && (grpCardFromPack.children.length > 0)){
            cardFrame = grpCardFromPack.children[0].cardFrame;
            grpCardFromPack.remove(grpCardFromPack.children[0]);
        }

        cardFrames = [];

        while((cardFrames.length < 3) && (cardPackNumbers.length > 0))
            cardFrames.push( cardPackNumbers.pop() );

        sprCardsFromPack = [];

        for(var i = 0; i < cardFrames.length; i++){

            var sprCard = grpSceneGame.create(0, 0, 'game', GetCardFrame(cardFrames[i]));
            sprCardsFromPack.push(sprCard);
            sprCard.visible = false;
            sprCard.anchor.set(0.5);
            grpCardFromPack.addChild(sprCard);

            if((cardPackNumbers.length == 0) && (grpCardFromPack.children.length == 1))
                sprCardPack.frameName = 'norecycle.png';

            LOG("A: " + cardPackNumbers.length + " B: " + grpCardFromPack.children.length);

            sprCard.cardFrame = cardFrames[i];
            sprCard.x = sprCardPack.x - grpCardFromPack.x;

            if(i == cardFrames.length - 1){

                var posTween = game.add.tween(sprCard);
                posTween.to( { x: sprCard.x / 2 }, DURATION_CARD_FLIP, "Linear", false);
                posTween.start();

                animatingFlip = true;
                var flipTween = game.add.tween(sprCard.scale);
                flipTween.to( { x: 0.05 * game.width / 680}, DURATION_CARD_FLIP, "Linear", false);
                flipTween.start();

                posTween.onStart.add(function(){
                    this.sprCard.visible = true;
                }, {sprCard:sprCard});

                sprCard.frameName = GetCardBackFrame();
                sprCard.inputEnabled = true;
                sprCard.events.onInputDown.add(scnGame.cardStartDrag, this);
                sprCard.events.onInputUp.add(scnGame.cardStopDrag, this);
                sprCard.secondClick = false;

                posTween.onComplete.add(scnGame.onPackCardFlipped, {sprCard:sprCard, destX:0})

            }else{
                sprCard.x = 0;
                sprCard.visible = false;
            }
        }

        if(cardPackNumbers.length == 0){
            sprCardPack.frameName = 'neniwaste.png';
            if(grpCardFromPack.length == 0)
                sprCardPack.frameName = 'norecycle.png';
        }
    },

    animateCardFlip: function(sprCard)
    {
        animatingFlip = true;
        sprCard.inputEnabled = false;
        var flipTween = game.add.tween(sprCard.scale);
        flipTween.to( { x:  0.05 * game.width / 680}, DURATION_CARD_FLIP, "Linear", 0);
        flipTween.onComplete.add(scnGame.onCardFlipped, {sprCard:sprCard})
        flipTween.start();
    },

    onCardFlipped: function(sprCard)
    {
        animatingFlip = true;
        this.sprCard.frameName = GetCardFrame(this.sprCard.cardFrame);
        var flipTween = game.add.tween(this.sprCard.scale);
        flipTween.to( { x:  1}, DURATION_CARD_FLIP, "Linear", 0);
        flipTween.onComplete.add(scnGame.onCardFlipFinished, {sprCard: this.sprCard})
        flipTween.start();
    },

    onPackCardFlipped: function(sprCard)
    {
        animatingFlip = true;
        this.sprCard.frameName = GetCardFrame(this.sprCard.cardFrame);

        var flipTween = game.add.tween(this.sprCard.scale);
        flipTween.to( { x:  1}, DURATION_CARD_FLIP, "Linear", 0);
        flipTween.start();
        flipTween.onComplete.add(scnGame.onCardFlipFinished, {sprCard:this.sprCard})

        var posTween = game.add.tween(this.sprCard);
        posTween.to( { x: this.destX}, DURATION_CARD_FLIP, "Linear", 0);
        posTween.start();

        //scnGame.IncMoves(+1);

        soundManager.playSound('card');
    },

    onPackCardFlippedBack: function()
    {
        animatingFlip = true;
        this.sprCard.frameName = GetCardBackFrame();

        scnGame.createNextUndoRecord();

        var flipTween = game.add.tween(this.sprCard.scale);
        flipTween.to( { x:  1 * game.width / 680}, DURATION_CARD_FLIP, "Linear", 0);
        flipTween.start();
        flipTween.onComplete.add(scnGame.onCardBackFlipFinished, {sprCard:this.sprCard})

        var posTween = game.add.tween(this.sprCard);
        posTween.to( { x: this.destX}, DURATION_CARD_FLIP, "Linear", 0);
        posTween.start();
    },

    onCardBackFlipFinished: function()
    {
        animatingFlip = false;

        this.sprCard.kill();
        sprCardPack.frameName = GetCardBackFrame();
    },

    onCardFlipFinished: function()
    {
        animatingFlip = false;

        this.sprCard.inputEnabled = true;

        scnGame.IncMoves(1);

        if(!GameData.profile.Draw1){
            scnGame.showAllCardsTakenFromPack();
            return;
        }

        /*
        if(!scnGame.autoplaceColorCard(this.sprCard))
            scnGame.checkCardSlotsForAutoplace();
        */

        scnGame.checkCardsForAutocomplete();
    },

    showAllCardsTakenFromPack: function()
    {
        animatingSlot = animatingSlot || (sprCardsFromPack.length > 0);
        for(var i = 0; i < sprCardsFromPack.length; i++){
            sprCardsFromPack[i].visible = true;
            sprCardsFromPack[i].inputEnabled = false;

            var tmpW = sprCardsFromPack[i].width * 0.45;
            var destX = i * tmpW;
            var posTween = game.add.tween(sprCardsFromPack[i]);
            posTween.to( { x: destX}, DURATION_CARD_FLIP, "Linear", 0);

            if(i == sprCardsFromPack.length - 1){
                posTween.onComplete.add(function(){
                    animatingSlot = false;
                });
                sprCardsFromPack[i].inputEnabled = true;
                sprCardsFromPack[i].events.onInputDown.add(scnGame.cardStartDrag, this);
                sprCardsFromPack[i].events.onInputUp.add(scnGame.cardStopDrag, this);
                sprCardsFromPack[i].secondClick = false;
            }

            posTween.start();
        }

    },

    checkCardsForAutocomplete: function()
    {
        if(gameAutocomplete != null)
            return false;

        LOG('checkCardsForAutocomplete')

        if(cardPackNumbers.length > 0)
            return false;

        if(grpCardFromPack.length > 0)
            return false;

        for(var i = 0; i < grpCardSlots.length; i++){
            if(grpCardSlots[i].length == 1)
                continue;

            for(var j = 1; j < grpCardSlots[i].length; j++)
                if(scnGame.IsCardBack(grpCardSlots[i].children[j])){
                    return false;
                }
        }

        soundManager.playSound('dialog');
        SceneAutocomplete.instance.onResolutionChange();
        ScenesTransitions.showSceneAlpha(grpAutocomplete, 0, ScenesTransitions.TRANSITION_LENGTH);

        return true;
    },

    checkCardSlotsForAutoplace: function()
    {
        for(var i = 0; i < grpCardSlots.length; i++){
            if(grpCardSlots[i].length == 1)
                continue;

            if(scnGame.autoplaceColorCard(grpCardSlots[i].children[grpCardSlots[i].length - 1]))
                return true;
        }

        return false;
    },

    autoplaceColorCard: function(card)
    {
        if(scnGame.IsCardBack(card))
            return false;

        if(cardSlotMoving.length > 0)
            return false;

        if(animatingFlip || animatingSlot)
            return false;

        var prevPos = card.worldPosition;
        var colour = Math.floor(card.cardFrame / 13);
        var sign = card.cardFrame % 13;

        if(!scnGame.allCardsSorted() && (sign > 1))
            return;

        for(var i = 0; i < grpColorSlots.length; i++) {
            if ((grpColorSlots[i].length == 0) && (sign != 0))
                continue;

            if ((grpColorSlots[i].length > 0) && (sign != 0)){
                var ColorSlotColor = grpColorSlots[i].children[0].cardFrame / 13;

                if(ColorSlotColor != colour)
                    continue;

                var ColorSlotSign = grpColorSlots[i].children[grpColorSlots[i].length - 1].cardFrame % 13;

                if(sign - ColorSlotSign != 1)
                    continue;
            }else{
                if(grpColorSlots[i].length > 0)
                    continue;

            }

            LOG("[" + card.cardFrame + "] autoplaceColorCard");

            cardSlotFrom = card.parent;
            var ColorSlotColor = grpColorSlots[i].children[0].cardFrame / 13;
            if(grpColorSlots[i].length + 1 > maxCardOfColor[ColorSlotColor])
                scnGame.IncScore(+10, false);

            scnGame.addOneCardToMovingSlot(cardSlotMoving, card);
            scnGame.placeMovingSlotToSlotAnimated(cardSlotMoving, grpColorSlots[i], 1.5);
            //scnGame.showNextCardFromSlot(grpCardSlots, parentSlot);
            return true;
        }

        return false;
    },

    allCardsSorted:function()
    {
        if((cardPackNumbers.length > 0) || (grpCardFromPack.children.length > 0))
            return;


        for(var i = 0; i < grpCardSlots.length; i++){
            if(grpCardSlots[i].length < 2)
                continue;
            if(scnGame.IsCardBack(grpCardSlots[i].children[1]))
            //if(grpCardSlots[i].children[1].key == "cardBack")
                return false;
            var prevSign = grpCardSlots[i].children[1].cardFrame % 13;
            for(var j = 2; j < grpCardSlots[i].length; j++) {
                var sign = grpCardSlots[i].children[j].cardFrame % 13;
                if(prevSign - sign != 1)
                    return false;
                prevSign = sign;
            }
        }

        return true;
    },

    addOneCardToMovingSlot: function(movingSlot, card)
    {
        movingSlot.x = card.worldPosition.x;//card.parent.x;
        movingSlot.y = card.worldPosition.y;//card.parent.y + card.y;
        movingSlot.add(card);
        game.tweens.removeFrom(card, true);
        card.x = 0; card.y = 0;
    },

    placeMovingSlotToSlot: function(movingSlot, newSlot)
    {
        if(movingSlot == newSlot){
            return;
        }

        //LOG("placeMovingSlotToSlot");

        while(movingSlot.length > 0){
            cardToRemove = movingSlot.children[0];
            stopAllTweensOnObject(cardToRemove.position);
            game.tweens.removeFrom(cardToRemove, true);
            cardToRemove.secondClick = false;
            cardToRemove.x = scnGame.getXPositionInNewSlot(newSlot);
            cardToRemove.y = scnGame.getYPositionInNewSlot(newSlot);
            newSlot.add(cardToRemove);
        }

        if(scnGame.isColorSlot(newSlot)) {
            var ColorSlotColor = newSlot.children[0].cardFrame / 13;
            var maxCard = newSlot.length;
            if (maxCardOfColor[ColorSlotColor] < maxCard)
                maxCardOfColor[ColorSlotColor] = maxCard;
        }

        scnGame.compactCardSlot(newSlot);

        if(newSlot != cardSlotFrom){
            if(!scnGame.showNextCardFromSlot(grpCardSlots, cardSlotFrom)){
                if(scnGame.isColorSlot(cardSlotFrom)){
                    scnGame.IncMoves(+1);
                    return;
                }
                scnGame.IncMoves(+1);
            }
        }

        if(grpCardFromPack.length > 0)
            LOG('XPOS  : ' + grpCardFromPack.children[grpCardFromPack.length - 1].x);


        if(scnGame.isCardSlot(newSlot) && (cardSlotFrom == grpCardFromPack))
            scnGame.IncScore(+5, true);
        //waste to tableau +5

        soundManager.playSound('card');

        if(scnGame.checkCardsForAutocomplete())
            return;

        if(gameAutocomplete)
            scnGame.checkCardSlotsForAutoplace();

        scnGame.testGameOver();
    },

    placeMovingSlotToSlotAnimated: function(movingSlot, newSlot, speedMul)
    {
        //LOG("placeMovingSlotToSlotAnimated");

        animationSpeedMul = speedMul || 1;

        //this.updateMovingSlot();
        animatingSlot = true;

        var destY = newSlot.y;
        if(!scnGame.isColorSlot(newSlot))
            destY = scnGame.getAbsoluteYPositionInNewSlot(newSlot);

        for(var i = 0; i < movingSlot.length; i++)
            movingSlot.children[i].inputEnabled = false;

        var dist = Math.sqrt(Math.pow(movingSlot.x - newSlot.x, 2) + Math.pow(movingSlot.y - destY, 2));

        var posTween = game.add.tween(movingSlot);
        posTween.to( { x: newSlot.x, y: destY}, Math.floor(dist * 10 / (DURATION_AUTO_PLACEMENT_MOVE_MULT * animationSpeedMul * game.width / 680)), "Linear", false);
        posTween.onComplete.add(scnGame.movingSlotHasMovedWithAnimation, {movingSlot:movingSlot, newSlot: newSlot});
        posTween.start();

        if(sprTintedCard != null) sprTintedCard.tint =  0xFFFFFF;
    },

    getYPositionInNewSlot: function(newSlot)
    {
        var destY = 0;

        if (newSlot.children.length > 0) {
            destY += newSlot.children[newSlot.children.length - 1].y;
            if (newSlot.children.length > 1) {
                destY += newSlot.children[newSlot.children.length - 1].y - newSlot.children[newSlot.children.length - 2].y;

                if (newSlot.children.length == 2){
                    for(var i = 0; i < grpCardSlots.length; i++)
                        if (newSlot == grpCardSlots[i])
                            destY += CARDS_DSPY;
                  }
            }
        }

        return destY;
    },

    getXPositionInNewSlot: function(newSlot)
    {
        if(GameData.profile.Draw1)
            return 0;

        if(newSlot != grpCardFromPack)
            return 0;

        var destX = 0;
        var tmpW = 0;

        for(var i = 0; i < grpCardFromPack.children.length; i++){
            tmpW = grpCardFromPack.children[i].width * 0.45;
            if(grpCardFromPack.children[i].x > destX)
                destX = grpCardFromPack.children[i].x;
        }

        if(sprCardsFromPack.length == 1)
            return destX;

        return destX + tmpW;
    },

    getAbsoluteYPositionInNewSlot: function(newSlot)
    {
        if(newSlot.children.length < 2)
            return newSlot.children[ newSlot.children.length - 1].worldPosition.y;

        return newSlot.children[ newSlot.children.length - 1].worldPosition.y + CARDS_DSPY;
    },

    movingSlotHasMovedWithAnimation: function()
    {
        //LOG("movingSlotHasMovedWithAnimation [" + this.movingSlot.children[0].x + ", " + this.movingSlot.children[0].y + "]")

        for(var i = 0; i < this.movingSlot.length; i++)
            this.movingSlot.children[i].inputEnabled = true;

        animatingSlot = false;
        scnGame.placeMovingSlotToSlot(this.movingSlot, this.newSlot);

        var colorSlotIdx = scnGame.getColorSlotIdx(this.newSlot);
        if(colorSlotIdx != -1)
            soundManager.playSound('harph' + colorSlotIdx);

        if(sprTintedCard != null) sprTintedCard.tint =  0xFFFFFF;

        if(cardPackNumbers.length == 0){
            sprCardPack.frameName = 'neniwaste.png';
            if(grpCardFromPack.length == 0)
                sprCardPack.frameName = 'norecycle.png';
        }
    },

    slotContainsCard: function(slot, card)
    {
        for(var i = 0; i < slot.length; i++)
            if(slot.children[i] == card)
                return true;

        return false;
    },

    showNextCardFromSlot: function(cardSlots, slot)
    {
        if(slot == grpCardFromPack){
            //skipUndoRecord = true;
            scnGame.GetNextCardFromPack(true);
        }

        slotIsCardSlot = false;

        for(var i = 0; i < cardSlots.length; i++){
            if(slot == cardSlots[i])
                slotIsCardSlot = true;
        }

        if(!slotIsCardSlot)
            return false;

        if(slot.length == 1)
            return false;

        LOG("showNextCardFromSlot");

        scnGame.compactCardSlot(slot);

        sprCard = slot.children[slot.length - 1];
        if(scnGame.IsCardBack(sprCard)){
            scnGame.animateCardFlip(sprCard);
            scnGame.IncScore(+5, false);
            return true;
        }

        return false;
    },

    IncScore: function(inc, LV)
    {
        gameScore += inc;
        if(LV)
            gameScoreLV += inc;

        scnGame.UpdateScoreTxtControl();

        if((GameData.profile.LasVegasScore && LV) || (!GameData.profile.LasVegasScore))
            SetPoingScaleTween(txtGameScoreVal);
    },

    IncMoves: function(inc, skipCreateUndoRec)
    {
        if(skipCreateUndoRec === undefined)
            skipCreateUndoRec = false;

        gameMoves += inc;
        txtGameMovesVal.text = '' + gameMoves;
        SetPoingScaleTween(txtGameMovesVal);

        if(!skipCreateUndoRec)
            scnGame.createNextUndoRecord();

        if(scnGame.UpdateAchievement(ACHIEVEMENT_CARDS1, inc))
            scnGame.ShowUnlockedAchievement(ACHIEVEMENT_CARDS1);
        if(scnGame.UpdateAchievement(ACHIEVEMENT_CARDS2, inc))
            scnGame.ShowUnlockedAchievement(ACHIEVEMENT_CARDS2);
    },

    compactCardSlot: function(cardSlot)
    {
        /*
        if(cardSlot == grpCardFromPack)
            return;

        for(var i = 0; i < 4; i++) {
            if (cardSlot == grpColorSlots[i])
                return;
        }

        var cntBacks = 0;
        var cntCards = 0;

        for(var i = 1; i < cardSlot.length; i++) {
            if (cardSlot.children[i].key == "cards")
                cntCards++;
            else
                cntBacks++;
        }


        var totalHeight = cardSlot.length * CARDS_DSPY;

        dspYBack = CARDS_DSPY;
        dspYCards = CARDS_DSPY;

        do{
            if(totalHeight > 560){
                dspYBack = dspYBack / 2;
                totalHeight = cntBacks * dspYBack + cntCards * dspYCards;
            }

            if(totalHeight > 560){
                dspYCards = dspYCards / 2;
                totalHeight = cntBacks * dspYBack + cntCards * dspYCards;
            }
        }while(totalHeight > 560);

        posY = 0;
        for(var i = 1; i < cardSlot.length; i++){
            var posTween = game.add.tween(cardSlot.children[i]);
            posTween.to( { y: posY}, 100, "Linear", true);
            posY += (cardSlot.children[i].key == "cards") ? dspYCards : dspYBack;
        }

        console.log("compactCardSlot [" + cardSlot.length + "] : " + posY);
        */
    },

    testGameOver: function()
    {
        //LOG("testGameOver");

        for(var i = 0; i < grpColorSlots.length; i++)
            if(grpColorSlots[i].children.length < 13)
                return;

        scnGame.GameOver();
    },

    isColorSlot: function(slot)
    {
        for(var i = 0; i < grpColorSlots.length; i++)
            if(grpColorSlots[i] == slot)
                return true;

        return false;
    },

    getColorSlotIdx: function(slot)
    {
        for(var i = 0; i < grpColorSlots.length; i++)
            if(grpColorSlots[i] == slot)
                return i;

        return -1;
    },

    isCardSlot: function(slot)
    {
        for(var i = 0; i < grpCardSlots.length; i++)
            if(grpCardSlots[i] == slot)
                return true;

        return false;
    },

    createNextUndoRecord: function()
    {
        if(skipUndoRecord) {
            skipUndoRecord = false;
            return false;
        }

        undoRecord = {};

        recCardPackNumbers = [];
        d = "";
        for(var i = 0; i < cardPackNumbers.length; i++){
            recCardPackNumbers[i] = cardPackNumbers[i];
            if(d.length > 0)d = d +" ,";
            d = d + cardPackNumbers[i];
        }
        d = "[ " + d +  " ]";
        //console.log(d);

        undoRecord['cpn'] = recCardPackNumbers;

        recCardSlots = [];
        for(var i = 0; i < grpCardSlots.length; i++){

            recCardSlot = [];
            for(var j = 1; j < grpCardSlots[i].length; j++)
                recCardSlot[j - 1] = scnGame.GetUndoRecCF(grpCardSlots[i].children[j]);
            recCardSlots[i] = recCardSlot;
        }

        undoRecord['cs'] = recCardSlots;

        recColorSlots = [];
        recColorSlotsMaxCard = [];
        for(var i = 0; i < grpColorSlots.length; i++){
            recColorSlotsMaxCard[i] = maxCardOfColor[i];
            recCardSlot = [];
            for(var j = 0; j < grpColorSlots[i].length; j++)
                recCardSlot[j] = scnGame.GetUndoRecCF(grpColorSlots[i].children[j]);
            recColorSlots[i] = recCardSlot;
        }

        undoRecord['cls'] = recColorSlots;
        undoRecord['clsmc'] = recColorSlotsMaxCard;

        recCardsFromPack = [];
        for(var i = 0; i < grpCardFromPack.children.length; i++)
            recCardsFromPack[i] = scnGame.GetUndoRecCF(grpCardFromPack.children[i]);

        undoRecord['cfp'] = recCardsFromPack;
        undoRecord['scr'] = gameScore;
        undoRecord['scrlv'] = gameScoreLV;
        undoRecord['wrcs'] = wasteRecycles;
        undoRecord['cfp3'] = sprCardsFromPack.length;

        var t1 = JSON.stringify(undoRecords[undoRecords.length - 1]);
        var t2 = JSON.stringify(undoRecord);

        var retVal = false;
        if((t1 != t2) || (undoRecords.length <= 1)){
            undoRecords.push(undoRecord);
            retVal = true;
            LOG("createNextUndoRecord()\n" + t2);
            GameData.profile.savedTime = gameTimer;
            GameData.profile.savedMoved = gameMoves;
            GameData.profile.savedScore = gameScore;
            GameData.profile.savedScoreLV = gameScoreLV;
            GameData.profile.savedGame = LZString.compressToUTF16(JSON.stringify(undoRecords));
            GameData.profile.savedWasteRecycles = wasteRecycles;

            GameData.Save();
        }else{
            LOG("createNextUndoRecord() - skipped");
        }

        LOG('UNDORECORDS : ' + undoRecords.length)

        /*
        while(undoRecords.length > 3)
            undoRecords.splice(0, 1);
        */
        return retVal;
    },

    GetUndoRecCF: function(sprCard)
    {
        var cf = sprCard.cardFrame;
        if(cf == 0) cf = 100;
        if(scnGame.IsCardBack(sprCard)) cf = -cf;
        return cf;
    },

    GameOver: function()
    {
        SceneGameOver.instance.ShowAnimated();
        scnGame.UpdateAchievementsTime(gameTimer);
        scnGame.UpdateAchievementsWin();
    },

    ResetGame: function()
    {
        //soundManager.playMusic(SOUND_GAME);
        gameTimer = 0;
        gameMoves = 0;
        gameScore = 0;
        gameScoreLV = -52;
        wasteRecycles = 0;
        gameAutocomplete = null;

        skipUndoRecord = false;
        animatingFlip = false;
        animatingSlot = false;

        undoRecords = [];
        //btnIngameUndo.frame = 1;

        cardPackNumbers = [];
        for(var i = 0; i < 52; i++)
            cardPackNumbers[i] = i;
        shuffleArray(cardPackNumbers);

        if(sprCardFromPack != null) sprCardFromPack.kill();
        sprCardPack.frameName = GetCardBackFrame();
        grpCardFromPack.removeAll(true);
        sprCardsFromPack = [];
        cardSlotFrom = null;

        for (var i = 0; i < 4; i++){
            grpColorSlots[i].removeAll(true);
            maxCardOfColor[i] = 0;
        }

        for (var i = 0; i < 7; i++) {
            grpCardSlots[i].removeAll(true);

            sprCardSlotHolder = grpCardSlots[i].create(0, 0, 'game', 'nenikral.png');
            sprCardSlotHolder.anchor.set(0.5);
            sprCardSlotHolder.cardFrame = CARD_SLOT_HOLDER;

            for (var j = 0; j <= i; j++) {
                cardFrame = cardPackNumbers.pop();
                if(j == i)
                    sprCard = grpSceneGame.create(0, j * CARDS_DSPY, 'game', GetCardFrame(cardFrame));
                else
                    sprCard = grpSceneGame.create(0, j * CARDS_DSPY, 'game', GetCardBackFrame());
                sprCard.cardFrame = cardFrame;
                grpCardSlots[i].add(sprCard);
                sprCard.anchor.set(0.5);
                game.physics.arcade.enable(sprCard);
                sprCard.inputEnabled = true;
                sprCard.events.onInputDown.add(scnGame.cardStartDrag, this);
                sprCard.events.onInputUp.add(scnGame.cardStopDrag, this);
                sprCard.secondClick = false;
            }
        }

        //Test konca balika
        //while(cardPackNumbers.length > 1)
        //    cardPackNumbers.pop();

        /*bestTime = GetStorageValue('sltr-best-', 0);

        sprIngameRecordStar.visible = false;
        txtIngameRecord.visible = false;
        if(bestTime != 0){
            sprIngameRecordStar.visible = true;
            txtIngameRecord.visible = true;
            this.SetTimerText(txtIngameRecord, bestTime);
        }*/

        txtGameTimeVal.text = '0:00';
        txtGameMovesVal.text = '' + gameMoves;
        scnGame.UpdateScoreTxtControl();
        scnGame.createNextUndoRecord();
        scnGame.onResolutionChange();

        if(GameData.profile.Draw1)
            GameData.profile.TotalGamesD1 ++;
        else
            GameData.profile.TotalGamesD3 ++;

        GameData.Save();

        cardDragStopEvents = [];

        soundManager.playSound('redeal');
        gameRunning = true;
    },

    RestoreSavedGame: function()
    {
        gameTimer = GameData.profile.savedTime;
        gameMoves = GameData.profile.savedMoved;
        gameScore = GameData.profile.savedScore;
        gameScoreLV = GameData.profile.savedScoreLV;
        wasteRecycles = GameData.profile.savedWasteRecycles;
        gameAutocomplete = null;

        skipUndoRecord = false;
        animatingFlip = false;
        animatingSlot = false;

        undoRecords = [];
        //btnIngameUndo.frame = 1;

        cardPackNumbers = [];
        for(var i = 0; i < 52; i++)
            cardPackNumbers[i] = i;
        shuffleArray(cardPackNumbers);

        if(sprCardFromPack != null) sprCardFromPack.kill();
        sprCardPack.frameName = GetCardBackFrame();
        grpCardFromPack.removeChildren();
        sprCardsFromPack = [];
        cardSlotFrom = null;

        for (var i = 0; i < 4; i++){
            grpColorSlots[i].removeAll(true);
            maxCardOfColor[i] = 0;
        }

        for (var i = 0; i < 7; i++) {
            grpCardSlots[i].removeAll(true);

            sprCardSlotHolder = grpCardSlots[i].create(0, 0, 'game', 'nenikral.png');
            sprCardSlotHolder.anchor.set(0.5);
            sprCardSlotHolder.cardFrame = CARD_SLOT_HOLDER;

            for (var j = 0; j <= i; j++) {
                cardFrame = cardPackNumbers.pop();
                if(j == i)
                    sprCard = grpSceneGame.create(0, j * CARDS_DSPY, 'game', GetCardFrame(cardFrame));
                else
                    sprCard = grpSceneGame.create(0, j * CARDS_DSPY, 'game', GetCardBackFrame());
                sprCard.cardFrame = cardFrame;
                grpCardSlots[i].add(sprCard);
                sprCard.anchor.set(0.5);
                game.physics.arcade.enable(sprCard);
                sprCard.inputEnabled = true;
                sprCard.events.onInputDown.add(scnGame.cardStartDrag, this);
                sprCard.events.onInputUp.add(scnGame.cardStopDrag, this);
                sprCard.secondClick = false;
            }
        }

        //Test konca balika
        //while(cardPackNumbers.length > 1)
        //    cardPackNumbers.pop();

        /*bestTime = GetStorageValue('sltr-best-', 0);

        sprIngameRecordStar.visible = false;
        txtIngameRecord.visible = false;
        if(bestTime != 0){
            sprIngameRecordStar.visible = true;
            txtIngameRecord.visible = true;
            this.SetTimerText(txtIngameRecord, bestTime);
        }*/

        txtGameTimeVal.text = millisecondsToTimeStr(gameTimer);
        txtGameMovesVal.text = '' + gameMoves;
        scnGame.UpdateScoreTxtControl();
        scnGame.onResolutionChange();

        undoRecords = JSON.parse(LZString.decompressFromUTF16(GameData.profile.savedGame));
        scnGame.ApplyUndoRecord(undoRecords[undoRecords.length - 1]);

        gameRunning = false;
    },

    cardStartDrag:function(card)
    {
        if(ScenesTransitions.transitionActive)
            return;

        if (!card.secondClick) {

            if(card.parent == cardSlotMoving){
                //scnGame.cardStopDrag(cardSlotMoving.children[0]);
                return;
            }

            if(animatingFlip || animatingSlot){
                scnGame.cardStopDrag(cardSlotMoving.children[0]);
                return;
            }

            if(cardSlotMoving.length > 0){
                scnGame.cardStopDrag(cardSlotMoving.children[0]);
                return;
            }

            LOG("[" + card.cardFrame + "] cardStartDrag {firstclick}");

            cardSlotFrom = card.parent;

            card.secondClick = true;

            touchDeltaX = card.worldPosition.x - game.input.x;
            touchDeltaY = card.worldPosition.y - game.input.y;

            //LOG("       touchDeltaY : " + touchDeltaY);

            scnGame.removeCardOrCardsFromSlot(card);
            scnGame.compactCardSlot(cardSlotFrom);
            game.world.bringToTop(cardSlotMoving);
            scnGame.updateMovingSlot();

            game.time.events.add(DOUBLECLICK_DELAY, function(){
                this.card.secondClick = false;
                //LOG("   [" + card.cardFrame + "] {secondclick = false}");
            },{card: card});

            return;
        }

        //LOG("[" + card.cardFrame + "] cardStartDrag {secondclick = true}");
        if(!scnGame.autoplaceCard(card)){
            ShakeObject(card);
            soundManager.playSound('nomove');
        }
    },

    removeCardOrCardsFromSlot: function(card)
    {
        cardToRemove = null;

        var startToRemove = false;
        for (var i = 0; i < cardSlotFrom.length; i++) {
            cardToRemove = cardSlotFrom.children[i];
            if (scnGame.IsCardSprite(cardToRemove) && (cardToRemove.cardFrame == card.cardFrame)) {
                /*
                if (cardToRemove.frame != cardToRemove.cardFrame){
                    scnGame.RemoveLastUndoRecord();
                    //btnIngameUndo.frame = (undoRecords.length == 0) ? 1 : 0;
                    return;
                }
                */
                startToRemove = true;
            }
            if (startToRemove) {
                cardSlotMoving.add(cardToRemove);
                game.tweens.removeFrom(cardToRemove, true);
                cardToRemove.x = 0;
                cardToRemove.y = (cardSlotMoving.length - 1) * CARDS_DSPY;
                colour = Math.floor(cardToRemove.cardFrame / 13);
                sign = cardToRemove.cardFrame % 13;
                i--;
            }

        }
    },

    autoplaceCard: function(card, oldCardPosInSlot)
    {
        //LOG("[" + card.cardFrame + "] autoplaceCard");

        if(oldCardPosInSlot === undefined)
            oldCardPosInSlot = -1;

        //if(card.key == "cardBack")
        if(scnGame.IsCardBack(card))
            return false;

        var prevPos = card.worldPosition;
        var colour = Math.floor(card.cardFrame / 13);
        var sign = card.cardFrame % 13;

        //K-s
        if(sign == 12){
            if(cardSlotMoving.length == 1)
                for(var i = 0; i < grpColorSlots.length; i++){
                    if(grpColorSlots[i].length < 12)
                        continue;
                    if(Math.floor(grpColorSlots[i].children[0].cardFrame / 13) != colour)
                        continue;
                    scnGame.addOneCardToMovingSlot(cardSlotMoving, card);
                    scnGame.placeMovingSlotToSlotAnimated(cardSlotMoving, grpColorSlots[i]);
                    scnGame.IncScore(+10, false);
                    //this.showNextCardFromSlot(grpCardSlots, cardSlotFrom);
                    return true;
                }

            for(var i = 0; i < grpCardSlots.length; i++){
                if(grpCardSlots[i].length == 1){
                    //moving to same slot is not an option...
                    if(cardSlotFrom == grpCardSlots[i])
                        continue;
                    //moving K from one empty slot to another is not an option...
                    if(oldCardPosInSlot == 1)
                        continue;
                    scnGame.addOneCardToMovingSlot(cardSlotMoving, card);
                    scnGame.placeMovingSlotToSlotAnimated(cardSlotMoving, grpCardSlots[i]);
                    //this.showNextCardFromSlot(grpCardSlots, cardSlotFrom);
                    return true;
                }
            }
            return;
        }

        //A-s
        if((sign == 0) && (cardSlotMoving.length == 1)){
            for(var i = 0; i < grpColorSlots.length; i++){
                if(grpColorSlots[i].length == 0){
                    scnGame.addOneCardToMovingSlot(cardSlotMoving, card);
                    scnGame.placeMovingSlotToSlotAnimated(cardSlotMoving, grpColorSlots[i]);
                    scnGame.IncScore(+10, false);
                    //this.showNextCardFromSlot(grpCardSlots, cardSlotFrom);
                    return true;
                }
            }
            card.secondClick = false;
            return false;
        }

        if(cardSlotMoving.length == 1)
            for(var i = 0; i < grpColorSlots.length; i++) {
                if (grpColorSlots[i].length == 0)
                    continue;
                var ColorSlotColor = grpColorSlots[i].children[0].cardFrame / 13;

                if(ColorSlotColor != colour)
                    continue;

                var ColorSlotSign = grpColorSlots[i].children[grpColorSlots[i].length - 1].cardFrame % 13;

                if(sign - ColorSlotSign != 1)
                    continue;

                scnGame.addOneCardToMovingSlot(cardSlotMoving, card);
                scnGame.placeMovingSlotToSlotAnimated(cardSlotMoving, grpColorSlots[i]);
                if(grpColorSlots[i].length + 1 > maxCardOfColor[ColorSlotColor])
                    scnGame.IncScore(+10, false);
                //this.showNextCardFromSlot(grpCardSlots, cardSlotFrom);
                return true;
            }

        for(var i = 0; i < grpCardSlots.length; i++) {
            if (grpCardSlots[i] == cardSlotFrom)
                continue;

            if (grpCardSlots[i].length == 1)
                continue;

            if(grpCardSlots[i].children[grpCardSlots[i].length - 1].key == "cardBack")
                continue;

            var ColorSlotColor = Math.floor(grpCardSlots[i].children[grpCardSlots[i].length - 1].cardFrame / 13);

            if(ColorSlotColor % 2 == colour % 2)
                continue;

            var ColorSlotSign = grpCardSlots[i].children[grpCardSlots[i].length - 1].cardFrame % 13;

            if(ColorSlotSign - sign != 1)
                continue;

            var OldAdjacentCard = cardSlotFrom.children[oldCardPosInSlot - 1];
            if(OldAdjacentCard !== undefined)
                if(!scnGame.IsCardBack(OldAdjacentCard)){
                    var OldAdjacentCardColor = Math.floor(OldAdjacentCard.cardFrame / 13);
                    var OldAdjacentCardSign = Math.floor(OldAdjacentCard.cardFrame % 13);

                    //moving cards between two same adjacent cards is not an option...
                    if((ColorSlotColor % 2 == OldAdjacentCardColor % 2) && (OldAdjacentCardSign == ColorSlotSign))
                        continue;
                    }

            scnGame.addOneCardToMovingSlot(cardSlotMoving, card);
            scnGame.placeMovingSlotToSlotAnimated(cardSlotMoving, grpCardSlots[i]);
            //this.showNextCardFromSlot(grpCardSlots, cardSlotFrom);
            return true;
        }

        //btnIngameUndo.frame = (undoRecords.length == 0) ? 1 : 0;
        scnGame.placeMovingSlotToSlot(cardSlotMoving, cardSlotFrom);

        return false;
    },

    updateMovingSlot: function()
    {
        if (cardSlotMoving.length == 0)
            return;

        if(animatingFlip || animatingSlot)
            return;

        cardSlotMoving.x = game.input.x + touchDeltaX;
        cardSlotMoving.y = game.input.y + touchDeltaY;

        //LOG("updateMovingSlot");

        cardUnderMovingSlot = scnGame.getCardUnderMovingSlot(cardSlotMoving, grpCardSlots);

        if(cardUnderMovingSlot == null){
            if(sprTintedCard != null)
                sprTintedCard.tint =  0xFFFFFF;
            return;
        }

        if(!scnGame.canCardBePlacedOnCardSlot(cardSlotMoving.children[0].cardFrame, cardUnderMovingSlot.cardFrame))
            cardUnderMovingSlot = null;

        if (cardUnderMovingSlot != null) {
            colour = Math.floor(cardUnderMovingSlot.cardFrame / 13);
            sign = cardUnderMovingSlot.cardFrame % 13;
            //console.log("cardUnderMovingSlot : " + cardUnderMovingSlot + " " + colour + " : " + sign);
            sprNewTintedCard = cardUnderMovingSlot;
            if(sprTintedCard != sprNewTintedCard){
                if(sprTintedCard != null)
                    sprTintedCard.tint =  0xFFFFFF;
                sprTintedCard = sprNewTintedCard;
            }
            sprTintedCard.tint =  0xBBBBBB;
        }

        if(cardSlotMoving.length > 1)
            return;

        colorSlotsUnderMovingSlot = scnGame.getColorSlotUnderMovingSlot();

        if(colorSlotsUnderMovingSlot != null){
            //console.log("colorSlotsUnderMovingSlot : " + colorSlotsUnderMovingSlot);
        }
    },

    getCardSlotUnderMovingSlot: function(movingSlot, cardSlots)
    {
        cardToTest = movingSlot.children[0];

        for(var i = 0; i < cardSlots.length; i++){
            if(scnGame.spritesOverlaps(cardToTest, cardSlots[i].children[cardSlots[i].length - 1]))
                return cardSlots[i];
        }

        return null;
    },

    getCardUnderMovingSlot: function(movingSlot, cardSlots)
    {
        cardToTest = movingSlot.children[0];

        for(var i = 0; i < cardSlots.length; i++){
            if(scnGame.spritesOverlaps(cardToTest, cardSlots[i].children[cardSlots[i].length - 1]))
                return cardSlots[i].children[cardSlots[i].length - 1];
        }

        return null;
    },

    getColorSlotUnderMovingSlot: function()
    {
        cardToTest = cardSlotMoving.children[0];

        for(var i = 0; i < cardHolder.length; i++){
            if(scnGame.spritesOverlaps(cardToTest, cardHolder[i]))
                return grpColorSlots[i];
        }

        return null;
    },

    getCardSlotByCard: function(card, cardSlots)
    {
        for(var i = 0; i < cardSlots.length; i++){
            for(var j = 0; j < cardSlots[i].length; j++){
                if(cardSlots[i].children[j] == card)
                    return cardSlots[i];
            }
        }

        return null;
    },

    spritesOverlaps: function(spr1, spr2)
    {
        deltaX = Math.abs(spr1.worldPosition.x - spr2.worldPosition.x);
        if(deltaX > spr1.width / 2)
            return false;

        deltaY = Math.abs(spr1.worldPosition.y - spr2.worldPosition.y);
        //LOG("deltaY : " + deltaY + "[" + spr1.height + "]");
        if(deltaY > spr1.height)
            return false;

        return true;
    },

    canCardBePlacedOnCardSlot: function(cardToPlace, cardInSlot)
    {
        colour1 = Math.floor(cardToPlace / 13);
        sign1 = cardToPlace % 13;

        if((sign1 == 12) && (cardInSlot == CARD_SLOT_HOLDER))
            return true;

        colour2 = Math.floor(cardInSlot / 13);
        sign2 = cardInSlot % 13;

        if((colour1 % 2) == (colour2 % 2))
            return false;
        if(sign1 - sign2 != -1)
            return false;

        return true;
    },

    IsCardSprite: function(spr)
    {
        if(spr.frameName.indexOf('karty') != 0)
            return false;

        return true;
    },

    IsCardBack: function(spr)
    {
        if(spr.frameName.indexOf('rub') != 0)
            return false;

        return true;
    },

    cardStopDrag: function(card)
    {
        if(card === undefined)
            return;

        if(card.secondClick){
            cardDragStopEvents.push({time: 10, card: this.card});
            /*
            game.time.events.add(10, function(){
                scnGame.cardStopDrag(this.card);
            },{card: card});
            */
            return;
        }

        if(animatingFlip || animatingSlot)
            return;

        if(cardSlotMoving.length < 1)
            return;

        if(!scnGame.slotContainsCard(cardSlotMoving, card))
            return;

        LOG("[" + card.cardFrame + "] cardStopDrag");

        cardUnderMovingSlot = scnGame.getCardUnderMovingSlot(cardSlotMoving, grpCardSlots);

        if(cardUnderMovingSlot != null){
            if (cardUnderMovingSlot.cardFrame == CARD_SLOT_HOLDER){
                //placing Ks on empty card slots
                if(cardSlotMoving.children[0].cardFrame % 13 != 12){
                    //scnGame.RemoveLastUndoRecord();
                    //btnIngameUndo.frame = (undoRecords.length == 0) ? 1 : 0;
                    scnGame.placeMovingSlotToSlot(cardSlotMoving, cardSlotFrom);
                    return;
                }

                newSlot = scnGame.getCardSlotUnderMovingSlot(cardSlotMoving, grpCardSlots);

                scnGame.placeMovingSlotToSlot(cardSlotMoving, newSlot);
                if(newSlot != cardSlotFrom)
                    scnGame.showNextCardFromSlot(grpCardSlots, cardSlotFrom);
                else {
                    //scnGame.RemoveLastUndoRecord();
                    //btnIngameUndo.frame = (undoRecords.length == 0) ? 1 : 0;
                }
                if(sprTintedCard != null) sprTintedCard.tint =  0xFFFFFF;
                return;
            }

            if(!scnGame.canCardBePlacedOnCardSlot(cardSlotMoving.children[0].cardFrame, cardUnderMovingSlot.cardFrame))
                cardUnderMovingSlot = null;

            if (cardUnderMovingSlot != null) {
                newSlot = scnGame.getCardSlotByCard(cardUnderMovingSlot, grpCardSlots);
                scnGame.placeMovingSlotToSlot(cardSlotMoving, newSlot);
                //if (newSlot != cardSlotFrom)
                //   scnGame.showNextCardFromSlot(grpCardSlots, cardSlotFrom);

                if(sprTintedCard != null) sprTintedCard.tint =  0xFFFFFF;
                return;
            }
        }

        if(cardSlotMoving.length > 1){
            //scnGame.RemoveLastUndoRecord();
            //btnIngameUndo.frame = (undoRecords.length == 0) ? 1 : 0;
            scnGame.placeMovingSlotToSlot(cardSlotMoving, cardSlotFrom);
            if(sprTintedCard != null) sprTintedCard.tint =  0xFFFFFF;
            return;
        }

        colorSlotsUnderMovingSlot = scnGame.getColorSlotUnderMovingSlot();

        if(!scnGame.canCardBePlacedOnColorSlot(cardSlotMoving.children[0].cardFrame, colorSlotsUnderMovingSlot))
            colorSlotsUnderMovingSlot = null;

        if(colorSlotsUnderMovingSlot != null){
            var slotColor = Math.floor(cardSlotMoving.children[0].cardFrame / 13);
            if(colorSlotsUnderMovingSlot.length + 1 > maxCardOfColor[slotColor])
                scnGame.IncScore(+10, false);
            scnGame.placeMovingSlotToSlot(cardSlotMoving, colorSlotsUnderMovingSlot);
            //scnGame.showNextCardFromSlot(grpCardSlots, cardSlotFrom);
        }else{
            //scnGame.RemoveLastUndoRecord();
            //btnIngameUndo.frame = (undoRecords.length == 0) ? 1 : 0;
            scnGame.placeMovingSlotToSlot(cardSlotMoving, cardSlotFrom);
        }

        if(sprTintedCard != null) sprTintedCard.tint =  0xFFFFFF;
    },

    RemoveLastUndoRecord: function()
    {
        if(undoRecords.length <= 1)
            return;

        undoRecords.pop();
    },

    canCardBePlacedOnColorSlot: function(cardToPlace, colorSlot)
    {
        if(colorSlot == null)
            return false;

        colour1 = Math.floor(cardToPlace / 13);
        sign1 = cardToPlace % 13;

        if(colorSlot.children.length == 0)
            return (sign1 == 0);

        cardFrame = colorSlot.children[colorSlot.children.length - 1].cardFrame;
        colour2 = Math.floor(cardFrame / 13);
        sign2 = cardFrame % 13;

        if(colour1 != colour2)
            return false;
        if(sign1 - sign2 != 1)
            return false;

        return true;

    },

    //endregion

    //region BOTTOM BUTTONS

    OnPressedIngameHint: function()
    {
        if(animatingFlip || animatingSlot)
            return;

        soundManager.playSound('menu-click1');

        touchDeltaX = 0;
        touchDeltaY = 0;

        if(grpCardFromPack.children.length > 0){
            cardSlotFrom = grpCardFromPack;
            var sprCard = grpCardFromPack.children[grpCardFromPack.children.length - 1];
            scnGame.removeCardOrCardsFromSlot(sprCard);

            if (scnGame.autoplaceCard(sprCard)){
                scnGame.UpdateAchievementsHint();
                return;
            }

            scnGame.placeMovingSlotToSlot(cardSlotMoving, cardSlotFrom);
        }

        for(var i = 0; i < grpCardSlots.length; i++) {
            cardSlotFrom = grpCardSlots[i];
            for (var j = 1; j < grpCardSlots[i].length; j++) {
                if (scnGame.IsCardBack(grpCardSlots[i].children[j]))
                    continue;

                var card = grpCardSlots[i].children[j];
                scnGame.removeCardOrCardsFromSlot(card);

                if (scnGame.autoplaceCard(card, j)){
                    scnGame.UpdateAchievementsHint();
                    return;
                }

                scnGame.placeMovingSlotToSlot(cardSlotMoving, cardSlotFrom);
            }
        }

        /*
        for(var i = 0; i < grpColorSlots.length; i++) {
            cardSlotFrom = grpColorSlots[i];
            for (var j = 0; j < grpColorSlots[i].length; j++) {
                if (scnGame.IsCardBack(grpColorSlots[i].children[j]))
                    continue;

                if (scnGame.autoplaceCard(grpColorSlots[i].children[j])) {
                    scnGame.UpdateAchievementsHint();
                    return;
                }
            }
        }
        */

        ShakeObject(ingameButtons[1]);
        soundManager.playSound('nomove');
    },

    OnPressedIngameUndo: function()
    {
        LOG("OnPressedIngameUndo()");

        if(animatingFlip || animatingSlot)
            return;

        soundManager.playSound('menu-click1');
        if(undoRecords.length <= 1) {
            ShakeObject(ingameButtons[2]);
            soundManager.playSound('nomove');
            return;
        }

        undoRecord = undoRecords.pop();
        scnGame.UpdateAchievementsUndo();
        undoRecord = undoRecords[undoRecords.length - 1];

        soundManager.playSound('undo');
        scnGame.ApplyUndoRecord(undoRecord);
        scnGame.IncMoves(+1, true);
    },

    DebugApplyUndoRecord: function(undoRecord)
    {
        undoRecords = [];
        undoRecords.push(undoRecord);
        scnGame.ApplyUndoRecord(undoRecord);
    },

    RetryGame: function()
    {
        if(undoRecords.length == 0)
            return;

        undoRecord = undoRecords[0];

        gameTimer = 0;
        gameMoves = 0;
        gameScore = 0;
        gameScoreLV = -52;
        wasteRecycles = 0;
        gameAutocomplete = null;

        scnGame.ApplyUndoRecord(undoRecord);
        undoRecords = [];

        scnGame.createNextUndoRecord();
        scnGame.onResolutionChange();

        txtGameTimeVal.text = '0:00';
        txtGameMovesVal.text = '' + gameMoves;
        scnGame.UpdateScoreTxtControl();

        skipUndoRecord = false;
        animatingFlip = false;
        animatingSlot = false;
        cardSlotFrom = null;

        if(GameData.profile.Draw1)
            GameData.profile.TotalGamesD1 ++;
        else
            GameData.profile.TotalGamesD3 ++;

        GameData.Save();

        soundManager.playSound('redeal');
        gameRunning = true;
    },

    ApplyUndoRecord: function(undoRecord)
    {
        game.time.desiredFps = SAVED_FPS;

        recCardPackNumbers = undoRecord['cpn'];
        recCardSlots = undoRecord['cs'];
        recColorSlots = undoRecord['cls'];
        recCardsFromPack = undoRecord['cfp'];
        gameScore = undoRecord['scr'];
        gameScoreLV = undoRecord['scrlv'];
        wasteRecycles = undoRecord['wrcs'];

        scnGame.UpdateScoreTxtControl();

        cardPackNumbers = [];
        for(var i = 0; i < recCardPackNumbers.length; i++)
            cardPackNumbers[i] = recCardPackNumbers[i];

        grpCardFromPack.removeChildren();

        for (var i = 0; i < 4; i++) {
            grpColorSlots[i].removeAll(true);
            maxCardOfColor[i] = undoRecord['clsmc'][i];
            for(var j = 0; j < recColorSlots[i].length; j ++){
                cardFrame = recColorSlots[i][j];
                sprCard = grpSceneGame.create(0, 0, 'game', GetCardFrame(cardFrame));
                sprCard.cardFrame = cardFrame;
                if(sprCard.cardFrame == 100) sprCard.cardFrame = 0;
                sprCard.anchor.set(0.5);
                game.physics.arcade.enable(sprCard);
                sprCard.inputEnabled = true;
                sprCard.events.onInputDown.add(scnGame.cardStartDrag, this);
                sprCard.events.onInputUp.add(scnGame.cardStopDrag, this);
                sprCard.secondClick = false;

                grpColorSlots[i].add(sprCard);
            }
        }

        for (var i = 0; i < 7; i++) {
            grpCardSlots[i].removeAll(true);

            sprCardSlotHolder = grpCardSlots[i].create(0, 0, 'game', 'nenikral.png');
            sprCardSlotHolder.anchor.set(0.5);
            sprCardSlotHolder.cardFrame = CARD_SLOT_HOLDER;

            for (var j = 0; j < recCardSlots[i].length; j++) {
                cardFrame = recCardSlots[i][j];
                if(cardFrame >= 0)
                    sprCard = grpSceneGame.create(0, (j) * CARDS_DSPY, 'game', GetCardFrame(cardFrame));
                else
                    sprCard = grpSceneGame.create(0, (j) * CARDS_DSPY, 'game', GetCardBackFrame());
                sprCard.cardFrame = Math.abs(cardFrame);
                if(sprCard.cardFrame == 100) sprCard.cardFrame = 0;
                sprCard.anchor.set(0.5);
                game.physics.arcade.enable(sprCard);
                sprCard.inputEnabled = true;
                sprCard.events.onInputDown.add(scnGame.cardStartDrag, this);
                sprCard.events.onInputUp.add(scnGame.cardStopDrag, this);
                sprCard.secondClick = false;

                grpCardSlots[i].add(sprCard);
            }

            scnGame.compactCardSlot(grpCardSlots[i]);
        }

        grpCardFromPack.removeAll(true);
        for(var i = 0; i < recCardsFromPack.length; i++){
            cardFrame = recCardsFromPack[i];
            sprCard = grpSceneGame.create(0, 0, 'game', GetCardFrame(cardFrame));
            sprCard.cardFrame = cardFrame;
            if(sprCard.cardFrame == 100) sprCard.cardFrame = 0;
            sprCard.anchor.set(0.5);
            game.physics.arcade.enable(sprCard);

            if(i == recCardsFromPack.length - 1){
                sprCard.inputEnabled = true;
                sprCard.events.onInputDown.add(scnGame.cardStartDrag, this);
                sprCard.events.onInputUp.add(scnGame.cardStopDrag, this);
                sprCard.secondClick = false;
                sprCard.inputEnabled = true;
            }

            grpCardFromPack.addChild(sprCard);
        }

        sprCardsFromPack = [];

        var tmp3 = undoRecord['cfp3'];

        var idx = grpCardFromPack.children.length - 1;
        if(grpCardFromPack.children.length >= tmp3)
            for(var i = tmp3 - 1; i >= 0; i--){
                sprCardsFromPack[i] = grpCardFromPack.children[idx];
                idx --;
            }

        scnGame.showAllCardsTakenFromPack();

        undoRecord['cfp'] = recCardsFromPack;
        undoRecord['scr'] = gameScore;
        undoRecord['scrlv'] = gameScoreLV;
        undoRecord['wrcs'] = wasteRecycles;

        sprCardPack.frameName = GetCardBackFrame();
        if(cardPackNumbers.length == 0){
            sprCardPack.frameName = 'neniwaste.png';
            if(grpCardFromPack.length == 0)
                sprCardPack.frameName = 'norecycle.png';
        }

        cardDragStopEvents = [];

        scnGame.onResolutionChange();
    },

    UpdateScoreTxtControl: function()
    {
        if(GameData.profile.LasVegasScore)
            txtGameScoreVal.text = gameScoreLV + '$';
        else
            txtGameScoreVal.text = '' + gameScore;
    },

    //endregion

    //region HINTS

    UpdateAchievement: function(achievementIdx, inc, time)
    {
        return false;
    },

    ResetAchievement: function(achievementIdx)
    {
    },

    ShowUnlockedAchievement: function(achievementIdx)
    {
    },

    UpdateAchievementsTime: function(time)
    {
    },

    UpdateAchievementsWin: function()
    {
    },

    ResetAchievementsWinOnRestart: function()
    {
    },

    UpdateAchievementsUndo: function()
    {
    },

    UpdateAchievementsBestScore: function()
    {
    },

    UpdateAchievementsHint: function()
    {
    },

    //endregion

    //region SHOW & HIDE

    ShowAnimated: function()
    {
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Quadratic.Out;
        ScenesTransitions.showSceneAlpha(grpSceneGame, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
    },

    HideAnimated: function()
    {

    }

    //endregion
};

function GetSelectedBackground()
{
    return 'bg' + (GameData.profile.UsedBackground + 1);
};

function GetSelectedThemeTopBar()
{
    return 'hornybar_' + (GameData.profile.UsedBackground + 1) + '.png';
};

function GetSelectedThemeAchievementBar()
{
    return 'achievebar_' + (GameData.profile.UsedBackground + 1) + '.png';
};

function GetSelectedThemeAchievementFntColor()
{
    switch(GameData.profile.UsedBackground){
        case 0:
            return 0x3EA393;
        case 1:
            return 0x397294;
        case 2:
            return 0x246D26;
        case 3:
            return 0xE58975;
        case 4:
            return 0x293A56;

    }

    return 0xFFFFFF;
};

function GetSelectedThemeTopBarFontCol()
{
    switch(GameData.profile.UsedBackground){
        case 0:
        case 1:
        case 4:
            return 0x66aecb;
        case 2:
            return 0x4a9b43;
        case 3:
            return 0xf9e0b2;
    }

    return 0xFFFFFF;
};

function GetCardBackFrame()
{
    return 'rub' + (GameData.profile.UsedCardBack + 1) + '.png';
};

function GetCardFrame(cardIdx)
{
    if(cardIdx == 100)
        cardIdx = 0;

    return 'karty' + (GameData.profile.UsedCardFace + 1) + '_' + cardIdx + '.png';
};

function GetSelectedIngameButton()
{
    return 'ingamebtn_' + (GameData.profile.UsedBackground + 1) + '.png';
};
