
var SceneGameOver = function()
{
    SceneGameOver.instance = this;

    this.create();
};

SceneGameOver.instance = null;

SceneGameOver.prototype = {

    create: function ()
    {
        SceneGameOver.DURATION_VAL_ANIM = ScenesTransitions.TRANSITION_LENGTH / 0.72;
        SceneGameOver.DELAY_VAL_ANIM = ScenesTransitions.TRANSITION_LENGTH / 1.8;

        grpSceneGameOver = game.add.group();
        grpSceneGameOver.name = "grpSceneGameOver";
        this.grpScene = grpSceneGameOver;

        imgGameOverBG = game.add.sprite(game.width >> 1, game.height, GetSelectedBackground());
        imgGameOverBG.anchor.setTo(0.5, 1);
        grpSceneGameOver.addChild(imgGameOverBG);
        imgGameOverBG.inputEnabled = true;

        imgGameOverShine = game.add.sprite(game.width >> 1, (game.height * 0.52), 'pak1', 'luce.png');
        //imgGameOverShine.blendMode = PIXI.blendModes.ADD;
        imgGameOverShine.anchor.setTo(0.5, 0.5);
        imgGameOverShine.scale.set(2.7);
        grpSceneGameOver.addChild(imgGameOverShine);

        gotGameOverRecord = false;

        //region TITLEF

        imgGameOverRibbon = game.add.sprite(game.width >> 1, game.height, 'pak1', 'winbanner.png');
        imgGameOverRibbon.anchor.setTo(0.5, 0.5);
        imgGameOverRibbon.scale.set(game.width / 680);
        imgGameOverRibbon.visible = false;
        grpSceneGameOver.addChild(imgGameOverRibbon);

        topBarGameOver = gameState.CreateCaptionBar(grpSceneGameOver, '');
        topBarGameOver.frameName = 'void.png';
        topBarGameOver.txtCaption.visible = false;
        imgGameOverCoinsHolder = gameState.CreateCoinsHolder(grpSceneGameOver, topBarGameOver);

        txtGameOverTitle = gameState.CreateText(0, -10, 'gamefont', 'You win!', 38);
        txtGameOverTitle.anchor.setTo(0.5, 0.5);
        txtGameOverTitle.tint = 0x274e6b;
        imgGameOverRibbon.addChild(txtGameOverTitle);

        //endregion

        //region CARDS
        imgGameOverCards = [];
        for(var j = 0; j < 4; j++) {
            imgGameOverCards[j] = [];
            for (var i = 0; i < 13; i++) {
                imgGameOverCards[j][i] = game.add.sprite(-1000, -1000, 'game', GetCardFrame(j * 13 + i));
                imgGameOverCards[j][i].scale.set(game.width / 680 * 0.7);
                imgGameOverCards[j][i].anchor.set(0.5);
                imgGameOverCards[j][i].twnMove = null;
                grpSceneGameOver.add(imgGameOverCards[j][i]);
            }
        }

        tmpy = (game.height * 0.27);

        cardsDestinations = [];

        cardsDestinations[0] = {x:(game.width >> 1) - game.width / 3, y: tmpy};
        cardsDestinations[1] = {x:game.width >> 1,  y: tmpy - game.height * 0.1};
        cardsDestinations[2] = {x:(game.width >> 1) + game.width / 3, y: tmpy};
        cardsDestinations[3] = {x:game.width >> 1,  y: tmpy + game.height * 0.1};

        //endregion

        //region BARs

        imgGameOverBar1 = game.add.sprite(game.width >> 1, game.height >> 1, 'pak1', 'blank.png');
        imgGameOverBar1.anchor.setTo(0.5, 0.5);
        imgGameOverBar1.tint = 0x26631e;
        grpSceneGameOver.addChild(imgGameOverBar1);

        imgGameOverBar2 = game.add.sprite(game.width >> 1, game.height >> 1, 'pak1', 'blank.png');
        imgGameOverBar2.anchor.setTo(0.5, 0.5);
        imgGameOverBar2.tint = 0x327d30;
        grpSceneGameOver.addChild(imgGameOverBar2);

        //endregion

        //region COINS

        imgGameOverBonusBG = game.add.sprite(game.width >> 1, game.height, 'pak1', 'bonuswindow.png');
        imgGameOverBonusBG.anchor.setTo(0.5, 0.5);
        imgGameOverBonusBG.scale.set(game.width / 680);
        imgGameOverBonusBG.dspX = 0;
        grpSceneGameOver.addChild(imgGameOverBonusBG);

        imgGameOverBonusFG = game.add.sprite(-61, 0, 'pak1', 'bonusvnutro.png');
        imgGameOverBonusFG.anchor.setTo(0.5, 0.5);
        imgGameOverBonusBG.addChild(imgGameOverBonusFG);

        imgGameOverBonusCoin = game.add.sprite(25, 0, 'pak1', 'mincaB.png');
        imgGameOverBonusCoin.anchor.setTo(0.5, 0.5);
        imgGameOverBonusCoin.scale.set(0.4);
        imgGameOverBonusFG.addChild(imgGameOverBonusCoin);

        txtGameOverBonusDailyVal = gameState.CreateText(5, -2, 'gamefont', '10', 30);
        txtGameOverBonusDailyVal.anchor.setTo(1, 0.5);
        txtGameOverBonusDailyVal.tint = 0xffffff;
        imgGameOverBonusFG.addChild(txtGameOverBonusDailyVal);

        imgGameOverBonusDaily = game.add.sprite(55, 0, 'pak1', 'daily.png');
        imgGameOverBonusDaily.anchor.setTo(0.5, 0.5);
        imgGameOverBonusDaily.scale.set(0.7);
        imgGameOverBonusBG.addChild(imgGameOverBonusDaily);
        /*
        txtGameOverBonusDaily = gameState.CreateText(55, 0, 'gamefont', 'Daily', 30);
        txtGameOverBonusDaily.anchor.setTo(0.5, 0.5);
        txtGameOverBonusDaily.tint = 0x2d5572;
        txtGameOverBonusDaily.align = 'center';
        imgGameOverBonusBG.addChild(txtGameOverBonusDaily);
        */

        imgGameOverCoin = game.add.sprite(25, -5, 'pak1', 'mincaB.png');
        imgGameOverCoin.anchor.setTo(0.5, 0.5);
        imgGameOverCoin.scale.set(0.7 * game.width / 680);
        grpSceneGameOver.addChild(imgGameOverCoin);

        txtGameOverCoinVal = gameState.CreateText(5, -game.width * 0.03, 'gamefont', '10', 50 * game.width / 680);
        txtGameOverCoinVal.anchor.setTo(1, 0.5);
        txtGameOverCoinVal.tint = 0xffffff;
        grpSceneGameOver.addChild(txtGameOverCoinVal);

        //endregion

        //region BUTTONS

        btnGameOverNewgame = gameState.CreateImgButtonWithIcon(grpSceneGameOver, 'winnewgame.png', 'newgame_icon.png', function(){
            soundManager.playSound('menu-click1');
            SceneGame.instance.ResetGame();
            SceneGameOver.instance.HideAnimated();
        }, 0x56351f);
        btnGameOverNewgame.scale.set(game.width / 680);

        btnGameOverRetry = gameState.CreateImgButtonWithIcon(grpSceneGameOver, 'dialogbutton.png', 'WINretry.png', function(){
            coinParticles.Reset();
            soundManager.playSound('menu-click1');
            SceneGame.instance.RetryGame();
            SceneGameOver.instance.HideAnimated();
        }, 0x4281a5);
        btnGameOverRetry.scale.set(game.width / 680);

        btnGameOverHome = gameState.CreateImgButtonWithIcon(grpSceneGameOver, 'dialogbutton.png', 'WINhome.png', function(){
            coinParticles.Reset();
            soundManager.playSound('menu-click1');
            coinParticles.Reset();
            SceneGame.instance.HideAnimated();
            SceneGameOver.instance.HideAnimated();

            SceneMenu.instance.onResolutionChange();
            SceneMenu.instance.ShowAnimated();

            selectedMenuButton = null;
            SceneMenu.instance.SelectMenuButtonAnimated(btnMenuButtons[2]);

        }, 0x4281a5);
        btnGameOverHome.scale.set(game.width / 680);

        //endregion

        //region STATS


        imgGameOverTime = game.add.sprite(0, 0, 'game', 'topbar_0.png');
        imgGameOverTime.anchor.setTo(0.5, 0.5);
        imgGameOverTime.scale.set(0.8);
        grpSceneGameOver.addChild(imgGameOverTime);

        imgGameOverScore = game.add.sprite(0, 0, 'game', 'topbar_2.png');
        imgGameOverScore.anchor.setTo(0.5, 0.5);
        imgGameOverScore.scale.set(0.8);
        grpSceneGameOver.addChild(imgGameOverScore);

        imgGameOverTotalW = game.add.sprite(0, 0, 'pak1', 'autocomplete.png');
        imgGameOverTotalW.anchor.setTo(0.5, 0.5);
        imgGameOverTotalW.scale.set(0.3);
        grpSceneGameOver.addChild(imgGameOverTotalW);

        /*
        txtGameOverScore = gameState.CreateText(30, 0, 'gamefont', 'SCORE', 32 * game.width / 680);
        txtGameOverScore.anchor.setTo(0, 0.5);
        txtGameOverScore.tint = 0xffffff;
        grpSceneGameOver.addChild(txtGameOverScore);

        txtGameOverTime = gameState.CreateText(30, 0, 'gamefont', 'TIME', 32 * game.width / 680);
        txtGameOverTime.anchor.setTo(0, 0.5);
        txtGameOverTime.tint = 0xffffff;
        grpSceneGameOver.addChild(txtGameOverTime);

        txtGameOverTotalW = gameState.CreateText(30, 0, 'gamefont', STR('STATS_TOTAL_WINS'), 32 * game.width / 680);
        txtGameOverTotalW.anchor.setTo(0, 0.5);
        txtGameOverTotalW.tint = 0xffffff;
        grpSceneGameOver.addChild(txtGameOverTotalW);
        */

        txtGameOverScoreVal = gameState.CreateText(30, 0, 'gamefont', '425', 32 * game.width / 680);
        txtGameOverScoreVal.anchor.setTo(1, 0.5);
        txtGameOverScoreVal.tint = 0x9cd8e4;
        grpSceneGameOver.addChild(txtGameOverScoreVal);

        imgGameOverScoreValBest = game.add.sprite(game.width * 0.044, 0, 'pak1', 'bestscore.png');
        imgGameOverScoreValBest.anchor.setTo(0.5, 0.5);
        imgGameOverScoreValBest.scale.set(0.6 * game.width / 680);
        txtGameOverScoreVal.addChild(imgGameOverScoreValBest);

        txtGameOverScoreValBest = gameState.CreateText(game.width * 0.14, -game.width * 0.008, 'gamefont', 'Best\nscore', 20 * game.width / 680);
        txtGameOverScoreValBest.anchor.setTo(0.5, 0.5);
        txtGameOverScoreValBest.tint = 0xfbc55a;
        txtGameOverScoreValBest.align = 'center';
        txtGameOverScoreVal.addChild(txtGameOverScoreValBest);
        txtGameOverScoreValBest.visible = false;

        txtGameOverTimeVal = gameState.CreateText(game.width * 0.044, 0, 'gamefont', '05:47', 32 * game.width / 680);
        txtGameOverTimeVal.anchor.setTo(1, 0.5);
        txtGameOverTimeVal.tint = 0x9cd8e4;
        grpSceneGameOver.addChild(txtGameOverTimeVal);

        imgGameOverTimeValBest = game.add.sprite(game.width * 0.044, 0, 'pak1', 'bestscore.png');
        imgGameOverTimeValBest.anchor.setTo(0.5, 0.5);
        imgGameOverTimeValBest.scale.set(0.6);
        txtGameOverTimeVal.addChild(imgGameOverTimeValBest);

        txtGameOverTimeValBest = gameState.CreateText(game.width * 0.14, -game.width * 0.008, 'gamefont', 'Best\ntime', 32 * game.width / 680);
        txtGameOverTimeValBest.anchor.setTo(0.5, 0.5);
        txtGameOverTimeValBest.tint = 0xfbc55a;
        txtGameOverTimeValBest.align = 'center';
        txtGameOverTimeVal.addChild(txtGameOverTimeValBest);
        txtGameOverTimeValBest.visible = false;

        txtGameOverTotalWVal = gameState.CreateText(game.width * 0.044, 0, 'gamefont', '29',  32 * game.width / 680);
        txtGameOverTotalWVal.anchor.setTo(1, 0.5);
        txtGameOverTotalWVal.tint = 0x9cd8e4;
        grpSceneGameOver.addChild(txtGameOverTotalWVal);
        //endregion

        grpSceneGameOver.visible = false;
    },

    UpdateGamesStats: function()
    {
        GameData.profile.savedGame = null;
        GameData.Save();

        coinsWon = 10;

        if(GameData.profile.Draw1){
            txtGameOverTotalWVal.text = '' + GameData.profile.TotalWinsD1;
            GameData.profile.TotalWinsD1 ++;
        }
        else{
            txtGameOverTotalWVal.text = '' + GameData.profile.TotalWinsD3;
            GameData.profile.TotalWinsD3 ++;
        }
        imgGameOverCoinsHolder.txtPrice.text = '' + GameData.profile.PlayerCoins;
        txtGameOverCoinVal.text = '' + coinsWon;

        GameData.profile.PlayerCoins += coinsWon;

        gotGameOverRecord = false;

        imgGameOverScoreValBest.visible = false;
        txtGameOverScoreValBest.visible = false;
        imgGameOverTimeValBest.visible = false;
        txtGameOverTimeValBest.visible = false;
    },

    ReloadCardFaces: function()
    {

    },

    ReloadCardBacks: function()
    {

    },

    ResetGameOverCards: function()
    {
        for (var j = 0; j < imgGameOverCards.length; j++)
            for (var i = 0; i < imgGameOverCards[j].length; i++) {
                try{
                    imgGameOverCards[j][i].frameName = GetCardFrame(grpColorSlots[j].children[0].cardFrame + i);
                }catch(e){
                    imgGameOverCards[j][i].frameName = GetCardFrame(j * 13 + i);
                }
                if (imgGameOverCards[j][i].twnMove != null)
                    imgGameOverCards[j][i].twnMove.stop();
                game.tweens.removeFrom(imgGameOverCards[j][i], true);
                imgGameOverCards[j][i].position.setTo(grpColorSlots[j].x, grpColorSlots[j].y);
            }
    },

    AnimateGameOverCards: function()
    {
        SceneGameOver.instance.ResetGameOverCards();

        cardsDestinations[0] = {x:(game.width >> 1) - game.width / 3, y: tmpy};
        cardsDestinations[1] = {x:game.width >> 1,  y: tmpy - game.height * 0.1};
        cardsDestinations[2] = {x:(game.width >> 1) + game.width / 3, y: tmpy};
        cardsDestinations[3] = {x:game.width >> 1,  y: tmpy + game.height * 0.1};

        var DURATION = ScenesTransitions.TRANSITION_LENGTH * 2;
        var DELAY = ScenesTransitions.TRANSITION_LENGTH / 3;

        for(var j = 0; j < imgGameOverCards.length; j++)
            for(var i = 0; i < imgGameOverCards[j].length; i++){
                var callback = ((j == imgGameOverCards.length - 1) && (i == imgGameOverCards[j].length - 1)) ? SceneGameOver.instance.CardsOnPositions : null;
                gameState.MoveSpriteBezier(imgGameOverCards[j][i], cardsDestinations[j].x, cardsDestinations[j].y, DURATION, j * (3 * ScenesTransitions.TRANSITION_LENGTH) + i * DELAY, 1, callback, null)
            }

    },

    AnimateGameOverStatValues: function()
    {
        imgGameOverCoin.dspX = 0;
        imgGameOverCoin.position.setTo((game.width >> 1) - imgGameOverCoin.dspX, imgGameOverBar1.top + (imgGameOverBar2.top - imgGameOverBar1.top) / 2);
        txtGameOverCoinVal.position.setTo(imgGameOverCoin.x - imgGameOverCoin.width * 0.5, imgGameOverCoin.y - game.width * 0.008);

        imgGameOverBonusBG.dspX = game.width * 0.6;
        imgGameOverBonusBG.position.setTo((game.width >> 1) + imgGameOverBonusBG.width * 0.3 + imgGameOverBonusBG.dspX, imgGameOverBar1.top + (imgGameOverBar2.top - imgGameOverBar1.top) / 2);

        var DURATION = 1000;
        var DELAY = 200;

        SceneGameOver.instance._animateScoreVal();
    },

    _animateScoreVal: function()
    {
        SceneGameOver.instance.TweenTextNumericVal(txtGameOverScoreVal, gameScore, SceneGameOver.DURATION_VAL_ANIM, SceneGameOver.DELAY_VAL_ANIM, SceneGameOver.instance._animateTimeVal);
    },

    _animateTimeVal: function()
    {
        soundManager.playSound('result_item_appear');
        SetPoingScaleTween(txtGameOverScoreVal);
        SceneGameOver.instance._updateScoreStuff();

        SceneGameOver.instance.TweenTextTimeVal(txtGameOverTimeVal, gameTimer, SceneGameOver.DURATION_VAL_ANIM, SceneGameOver.DELAY_VAL_ANIM, function(){
            soundManager.playSound('result_item_appear');
            SetPoingScaleTween(txtGameOverTimeVal);
            SceneGameOver.instance._updateTimeStuff();
            SetPoingScaleTween(txtGameOverTotalWVal, ScenesTransitions.TRANSITION_LENGTH, SceneGameOver.DELAY_VAL_ANIM, function(){
                soundManager.playSound('result_item_appear');
                if(GameData.profile.Draw1)
                    txtGameOverTotalWVal.text = '' + GameData.profile.TotalWinsD1;
                else
                    txtGameOverTotalWVal.text = '' + GameData.profile.TotalWinsD3;
                SceneGameOver.instance.AnimateGameOverWinnings();
            });
        });
    },

    _updateScoreStuff: function()
    {
        scnGame.UpdateAchievementsBestScore();
        if(GameData.profile.Draw1){
            if(GameData.profile.BestScoreD1 < gameScore){
                GameData.profile.BestScoreD1 = gameScore;
                imgGameOverScoreValBest.visible = true;
                txtGameOverScoreValBest.visible = true;
            }
        }else{
            if(GameData.profile.BestScoreD3 < gameScore){
                GameData.profile.BestScoreD3 = gameScore;
                gotGameOverRecord = true;
                imgGameOverScoreValBest.visible = false;
                txtGameOverScoreValBest.visible = false;
            }
        }
    },

    _animateTotalWinsVal: function()
    {

    },

    _updateTimeStuff: function()
    {
        if(GameData.profile.Draw1){
            if((GameData.profile.BestTimeD1 > gameTimer) || (GameData.profile.BestTimeD1 == 0)){
                GameData.profile.BestTimeD1 = gameTimer;
                gotGameOverRecord = true;
                imgGameOverTimeValBest.visible = false;
                txtGameOverTimeValBest.visible = false;
            }
            if((GameData.profile.LeastMovesD1 > gameMoves) || (GameData.profile.LeastMovesD1 == 0)){
                GameData.profile.LeastMovesD1 = gameMoves;
                gotGameOverRecord = true;
            }
            if(GameData.profile.MostMovesD1 < gameMoves){
                GameData.profile.MostMovesD1 = gameMoves;
                //toto asi nie je rekord....
                //gotGameOverRecord = true;
            }
        }else{
            if((GameData.profile.BestTimeD3 > gameTimer) || (GameData.profile.BestTimeD3 == 0)){
                GameData.profile.BestTimeD3 = gameTimer;
                gotGameOverRecord = true;
                imgGameOverTimeValBest.visible = false;
                txtGameOverTimeValBest.visible = false;
            }
            if((GameData.profile.LeastMovesD3 > gameMoves) || (GameData.profile.LeastMovesD3 == 0)){
                GameData.profile.LeastMovesD3 = gameMoves;
                gotGameOverRecord = true;
            }
            if(GameData.profile.MostMovesD3 < gameMoves){
                GameData.profile.MostMovesD3 = gameMoves;
                //toto asi nie je rekord....
                //gotGameOverRecord = true;
            }
        }
    },

    AnimateGameOverWinnings: function()
    {
        var dailyBonusAvail = new Date(GameData.profile.DailyBonusDate) <= (new Date());

        if(!dailyBonusAvail){
            coinParticles.AnimateCoins(coinsWon, imgGameOverCoin, imgGameOverCoinsHolder.itemCoin, txtGameOverCoinVal, imgGameOverCoinsHolder.txtPrice, function(){
                GameData.profile.PlayerCoins = imgGameOverCoinsHolder.txtPrice.val;
                GameData.Save();

                SceneGameOver.instance.AnimateGameOverCards();
            }, null, 0.8 * game.width / 680, 0.5 * game.width / 680);
            return;
        }

        GameData.profile.DailyBonusDate = StrDateNextDay(DateToStr(new Date()));
        GameData.Save();

        imgGameOverBonusBG.twnDspX = game.add.tween(imgGameOverBonusBG);
        imgGameOverBonusBG.twnDspX.to( { dspX: 0}, SceneGameOver.DURATION_VAL_ANIM, Phaser.Easing.Back.Out, true, SceneGameOver.DELAY_VAL_ANIM);

        imgGameOverBonusBG.twnDspX.onUpdateCallback(function(){
            imgGameOverBonusBG.position.setTo((game.width >> 1) + imgGameOverBonusBG.width * 0.3 + imgGameOverBonusBG.dspX, imgGameOverBar1.top + (imgGameOverBar2.top - imgGameOverBar1.top) / 2);
        }, this);

        imgGameOverCoin.twnDspX = game.add.tween(imgGameOverCoin);
        imgGameOverCoin.twnDspX.to( { dspX: imgGameOverBonusBG.width * 0.4}, SceneGameOver.DURATION_VAL_ANIM, Phaser.Easing.Back.Out, true, SceneGameOver.DELAY_VAL_ANIM);

        imgGameOverCoin.twnDspX.onUpdateCallback(function(){
            imgGameOverCoin.position.setTo((game.width >> 1) - imgGameOverCoin.dspX, imgGameOverBar1.top + (imgGameOverBar2.top - imgGameOverBar1.top) / 2);
            txtGameOverCoinVal.position.setTo(imgGameOverCoin.x - imgGameOverCoin.width * 0.5, imgGameOverCoin.y - game.width * 0.003);
        }, this);


        imgGameOverBonusBG.twnDspX.onComplete.add(function(){
            coinParticles.AnimateCoins(15, imgGameOverBonusCoin, imgGameOverCoin, txtGameOverBonusDailyVal, txtGameOverCoinVal, function(){
                coinParticles.AnimateCoins(txtGameOverCoinVal.val, imgGameOverCoin, imgGameOverCoinsHolder.itemCoin, txtGameOverCoinVal, imgGameOverCoinsHolder.txtPrice, function(){
                    GameData.profile.PlayerCoins = imgGameOverCoinsHolder.txtPrice.val;
                    GameData.Save();

                    SceneGameOver.instance.AnimateGameOverCards();
                }, null, 0.8 * game.width / 680, 0.5 * game.width / 680);
            }, null, 0.5 * game.width / 680, 0.8 * game.width / 680);
        });
    },

    TweenTextNumericVal: function(txtObj, val, duration, delay,callback)
    {
        txtObj.finVal = val;
        txtObj.val = 0;
        txtObj.twnVal = game.add.tween(txtObj);
        txtObj.twnVal.to( { val: val}, duration, "Linear", true, delay);
        txtObj.twnVal.onUpdateCallback(function(){
            this.txtObj.text = '' + Math.floor(this.txtObj.val);
        }, {txtObj : txtObj});
        txtObj.twnVal.onComplete.add(function(){
            this.txtObj.text = '' + Math.floor(this.txtObj.finVal);
            if(this.callback != null)
                this.callback();
        }, {txtObj : txtObj, callback: callback});

    },

    TweenTextTimeVal: function(txtObj, val, duration, delay, callback)
    {
        txtObj.finVal = val;
        txtObj.val = 0;
        txtObj.twnVal = game.add.tween(txtObj);
        txtObj.twnVal.to( { val: val}, duration, "Linear", true, delay);
        txtObj.twnVal.onUpdateCallback(function(){
            this.txtObj.text = '' + millisecondsToTimeStr(this.txtObj.val);
        }, {txtObj : txtObj});
        txtObj.twnVal.onComplete.add(function(){
            this.txtObj.text = '' + millisecondsToTimeStr(this.txtObj.finVal);
            if(this.callback != null)
                this.callback();
        }, {txtObj : txtObj, callback: callback});

    },

    CardsOnPositions: function()
    {
        LOG('CardsOnPositions');

        var tmp = cardsDestinations[0]
        for(var i = 0; i < cardsDestinations.length - 1; i++)
            cardsDestinations[i] = cardsDestinations[i + 1]
        cardsDestinations[cardsDestinations.length - 1] = tmp;

        var DURATION = 600;
        var DELAY = 100;

        for(var j = 0; j < imgGameOverCards.length; j++)
            for(var i = 0; i < imgGameOverCards[j].length; i++){
                var callback = ((j == imgGameOverCards.length - 1) && (i == imgGameOverCards[j].length - 1)) ? SceneGameOver.instance.CardsOnPositions : null;
                gameState.MoveSpriteBezier(imgGameOverCards[j][i], cardsDestinations[j].x, cardsDestinations[j].y, DURATION, j * 300 + i * DELAY, 1, callback, null)
            }


    },

    onResolutionChange: function()
    {
        imgGameOverBG.loadTexture(GetSelectedBackground());

        var itemH = game.height * 0.1;

        topBarGameOver.width = game.width;
        topBarGameOver.height = itemH;
        topBarGameOver.itemAnchor.scale.setTo(1 / topBarGameOver.scale.x, 1 / topBarGameOver.scale.y);
        topBarGameOver.y = topBarGameOver.height / 2;

        imgGameOverShine.height = game.height * 1.3;
        imgGameOverShine.scale.x = imgGameOverShine.scale.y;
        imgGameOverShine.position.setTo(game.width >> 1, (game.height * 0.52));

        imgGameOverBG.width = game.width;
        imgGameOverBG.scale.y = imgGameOverBG.scale.x;
        imgGameOverBG.position.setTo(game.width >> 1, game.height);

        imgGameOverRibbon.position.setTo(game.width >> 1, game.height / 17);

        imgGameOverBar1.width = game.width;
        imgGameOverBar1.height = game.height >> 1;
        imgGameOverBar1.position.setTo(game.width >> 1, game.height - (imgGameOverBar1.height >> 1));

        imgGameOverBar2.width = game.width;
        imgGameOverBar2.height = (imgGameOverBar1.height / 5) * 2;
        imgGameOverBar2.position.setTo(game.width >> 1, imgGameOverBar1.y - imgGameOverBar2.height / 3);// + (imgGameOverBG.height / 5));

        imgGameOverBonusBG.position.setTo((game.width >> 1) + imgGameOverBonusBG.width * 0.3 + imgGameOverBonusBG.dspX, imgGameOverBar1.top + (imgGameOverBar2.top - imgGameOverBar1.top) / 2);
        imgGameOverCoin.position.setTo((game.width >> 1) - imgGameOverCoin.dspX, imgGameOverBar1.top + (imgGameOverBar2.top - imgGameOverBar1.top) / 2);
        txtGameOverCoinVal.position.setTo(imgGameOverCoin.x - imgGameOverCoin.width * 0.5, imgGameOverCoin.y  - game.width*0.008);

        btnGameOverNewgame.position.setTo(game.width >> 1, game.height - imgGameOverBar2.height / 2 - btnGameOverNewgame.height * 0.55);
        btnGameOverRetry.position.setTo((game.width >> 1) - btnGameOverRetry.width / 2, game.height - imgGameOverBar2.height / 2 + btnGameOverNewgame.height * 0.45);
        btnGameOverHome.position.setTo((game.width >> 1) + btnGameOverRetry.width / 2, game.height - imgGameOverBar2.height / 2 + btnGameOverNewgame.height * 0.45);

        btnGameOverNewgame.imgIcon.scale.set(btnGameOverNewgame.scale.x * 0.6);
        btnGameOverRetry.imgIcon.scale.set(btnGameOverRetry.scale.x * 0.6);
        btnGameOverHome.imgIcon.scale.set(btnGameOverHome.scale.x * 0.6);

        imgGameOverScore.position.setTo((game.width >> 1) - game.width / 8, imgGameOverBar2.y - btnGameOverRetry.height * 0.7);
        imgGameOverTime.position.setTo((game.width >> 1) - game.width / 8, imgGameOverBar2.y);
        imgGameOverTotalW.position.setTo((game.width >> 1) - game.width / 8, imgGameOverBar2.y + btnGameOverRetry.height * 0.7);

        txtGameOverScoreVal.position.setTo((game.width >> 1) + game.width / 8, imgGameOverBar2.y - btnGameOverRetry.height * 0.7);
        txtGameOverTimeVal.position.setTo((game.width >> 1) + game.width / 8, imgGameOverBar2.y);
        txtGameOverTotalWVal.position.setTo((game.width >> 1) + game.width / 8, imgGameOverBar2.y + btnGameOverRetry.height * 0.7);

    },

    update: function()
    {
        imgGameOverShine.angle += 0.5;
    },

    updateTexts: function()
    {
        txtGameOverScoreValBest.text = STR('STATS_BEST_SCORE').replaceAll(' ','\n');
        txtGameOverTimeValBest.text = STR('STATS_BEST_TIME').replaceAll(' ','\n');

        /*
        txtGameOverBonusDaily.text = STR('DAILY_BONUS');
        updateBitmapTextToHeight(txtGameOverBonusDaily, 30, imgGameOverBonusBG.height * 0.9 / imgGameOverBonusBG.scale.x);
        updateBitmapTextToWidth(txtGameOverBonusDaily, txtGameOverBonusDaily.fontSize, imgGameOverBonusBG.width * 0.48 / imgGameOverBonusBG.scale.x);
        */

        txtGameOverTitle.text = STR('INGAME_RESULT_YOU_WIN');
        /*
        txtGameOverScore.text = STR('SCORE');
        txtGameOverTime.text = STR('TIME');
        txtGameOverTotalW.text = STR('STATS_TOTAL_WINS');

        updateBitmapTextToWidth(txtGameOverTitle, 38, imgGameOverRibbon.width * 0.67 / imgGameOverRibbon.scale.x);

        btnGameOverRetry.txtCaption.text = STR('RETRY');
        btnGameOverNewgame.txtCaption.text = STR('NEW_GAME');
        btnGameOverHome.txtCaption.text = STR('HOME');

        updateBitmapTextToWidth(btnGameOverRetry.txtCaption, 35, btnGameOverRetry.width * 0.8 / btnGameOverRetry.scale.x);
        updateBitmapTextToWidth(btnGameOverNewgame.txtCaption, 35, btnGameOverNewgame.width * 0.8 / btnGameOverNewgame.scale.x);
        updateBitmapTextToWidth(btnGameOverHome.txtCaption, 35, btnGameOverHome.width * 0.8 / btnGameOverHome.scale.x);
        */
    },

    ShowAnimated: function ()
    {
        soundManager.playSound('jingle_win');

        SceneGameOver.instance.onResolutionChange();
        SceneGameOver.instance.UpdateGamesStats();
        SceneGameOver.instance.ResetGameOverCards();
        SceneGameOver.instance.AnimateGameOverStatValues();

        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
        ScenesTransitions.showSceneAlpha(grpSceneGameOver, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
    },

    HideAnimated: function ()
    {
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
        ScenesTransitions.hideSceneAlpha(grpSceneGameOver, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
    }

}