
var SceneMenu = function()
{
    SceneMenu.instance = this;

    this.create();
};

SceneMenu.instance = null;


SceneMenu.prototype = {
    create: function () {
        grpSceneMenu = game.add.group();
        grpSceneMenu.name = 'grpSceneMenu';

        imgMenuBar = game.add.sprite((game.width >> 1), game.height, 'pak1', 'dolnybar.png');
        imgMenuBar.anchor.setTo(0.5, 1);
        imgMenuBar.width = game.width;
        imgMenuBar.height = 110;
        imgMenuBar.tint = 0x468faf;
        imgMenuBar.inputEnabled = true;
        grpSceneMenu.add(imgMenuBar);

        btnMenuButtons = [];

        btnMenuButtons.push(SceneMenu.instance.CreateMenuButton('btn_menu_0.png', SceneOptions.instance));
        btnMenuButtons.push(SceneMenu.instance.CreateMenuButton('btn_menu_2.png', ScenePlay.instance));
        btnMenuButtons.push(SceneMenu.instance.CreateMenuButton('btn_menu_1.png', SceneThemes.instance));

        this.SelectMenuButton(btnMenuButtons[1]);

        grpSceneMenu.visible = false;

        this.onResolutionChange();
    },

    QuitGame: function()
    {
        SceneDialog.instance.ShowAnimated('exit.png', 'autoYES.png', 'autoNO.png', function(){
            soundManager.playSound('menu-click1');
            navigator.app.exitApp();
        });
    },

    CreateMenuButton: function (iconSprOn, SceneInstance)
    {
        var menuButton = game.add.sprite((game.width >> 1), game.height - imgMenuBar.height / 2, 'pak1', iconSprOn);
        menuButton.anchor.setTo(0.5, 0.5);
        menuButton.scale.set(1);
        menuButton.SCALE = 1;
        grpSceneMenu.add(menuButton);
        AddButtonEvents(menuButton, SceneMenu.instance.SelectMenuButtonAnimated, ButtonOnInputOver, ButtonOnInputOut);

        menuButton.sceneInstance = SceneInstance;
        menuButton.grpScene = SceneInstance.grpScene;

        return menuButton;
    },

    SelectMenuButton: function(menuButton)
    {
        for(var i = 0; i < btnMenuButtons.length; i++){
            btnMenuButtons[i].alpha = 0.7;
            btnMenuButtons[i].scale.set(btnMenuButtons[i].SCALE);
            btnMenuButtons[i].grpScene.visible = false;
        }

        menuButton.alpha = 1;
        menuButton.scale.set(btnMenuButtons[i] * 1.2);

        menuButton.grpScene.visible = true;
        menuButton.sceneInstance.onResolutionChange();

        selectedMenuButton = menuButton;
    },

    SelectMenuButtonAnimated: function(menuButton)
    {
        soundManager.playSound('menu-click1');

        menuButton = menuButton || this.button;

        if(selectedMenuButton == menuButton)
            return;

        ScenesTransitions.transitionStarted();

        var btnH = btnMenuButtons[0].height;

        if(selectedMenuButton != null){
            var tweenAlpha1 = game.add.tween(selectedMenuButton).to(   { alpha: 0.7 }, ScenesTransitions.TRANSITION_LENGTH / 5, "Linear", true);
            var tweenScale = game.add.tween(selectedMenuButton.scale).to(   { x: selectedMenuButton.SCALE, y:selectedMenuButton.SCALE}, ScenesTransitions.TRANSITION_LENGTH / 5, "Linear", true);
        }

        var moveToLeft = true;
        var skipShowNewScene = false;

        if(selectedMenuButton != null) {
            if (selectedMenuButton.x > menuButton.x)
                moveToLeft = false;

            ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Quintic.Out;

            if (moveToLeft)
                ScenesTransitions.hideSceneToLeft(selectedMenuButton.grpScene);
            else
                ScenesTransitions.hideSceneToRight(selectedMenuButton.grpScene);
        }

        selectedMenuButton = menuButton;

        selectedMenuButton.grpScene.alpha = 1;

        if(selectedMenuButton.sceneInstance == ScenePlay.instance){
            if(grpScenePause.visible)
                skipShowNewScene = true;
        }

        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Quintic.Out;

        if(!skipShowNewScene){
            if(moveToLeft)
                ScenesTransitions.showSceneFromRight(selectedMenuButton.grpScene, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
            else
                ScenesTransitions.showSceneFromLeft(selectedMenuButton.grpScene, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        }else
            ScenesTransitions.transitionFinished();

        var tweenAlpha2 = game.add.tween(selectedMenuButton).to(   { alpha: 1 }, ScenesTransitions.TRANSITION_LENGTH / 5, "Linear", true);
        var tweenScale2 = game.add.tween(selectedMenuButton.scale).to(   { x: selectedMenuButton.SCALE * 1.2, y:selectedMenuButton.SCALE * 1.2 }, ScenesTransitions.TRANSITION_LENGTH / 5, "Linear", true);

        SceneToReturnFromLanguage = null;

        selectedMenuButton.sceneInstance.onResolutionChange();
    },

    onResolutionChange: function()
    {
        imgMenuBar.width = game.width;
        imgMenuBar.height = game.height * 0.12;

        imgMenuBar.position.setTo(game.width >> 1, game.height);

        var btnW = game.width / (btnMenuButtons.length + 1);

        var posX = (game.width >> 1) - btnW;
        for(var i = 0; i < btnMenuButtons.length; i++){
            btnMenuButtons[i].width = btnW * 0.8;
            btnMenuButtons[i].scale.y = btnMenuButtons[i].scale.x;
            btnMenuButtons[i].SCALE = btnMenuButtons[i].scale.x;
            btnMenuButtons[i].position.x = posX;
            btnMenuButtons[i].position.y = game.height - (imgMenuBar.height >> 1) * 0.9;
            posX += btnW;
        }
    },

    UpdateAchievementsNotification: function()
    {
    },

    updateTexts: function()
    {
    },

    OnPressedPauseLang: function()
    {
        soundManager.playSound('menu-click1');

        SceneToReturnFromLanguage = SceneMenu.instance;

        SceneMenu.instance.HideAnimated();
        SceneLanguages.instance.ShowAnimated();
    },

    OnPressedPauseInstructions: function()
    {
        soundManager.playSound('menu-click1');

        SceneToReturnFromInstructions = SceneMenu.instance;

        SceneMenu.instance.HideAnimated();
        SceneInstructions.instance.ShowAnimated();
    },

    ShowAnimated: function(delay)
    {
        if(delay === undefined) delay = 0;

        soundManager.playSound('menu-click1');

        SceneMenu.instance.UpdateAchievementsNotification();
        ScenesTransitions.transitionStarted();
        ScenesTransitions.showSceneAlpha(grpSceneMenu, 0, 100);

        if(GameData.profile.savedGame != null){
            grpScenePlay.visible = false;
            grpScenePause.visible = true;
            ScenePause.instance.onResolutionChange();
        }

        delay += 200;
        for(var i = 0; i < btnMenuButtons.length; i++){
            ScenesTransitions.showSceneScale(btnMenuButtons[i], delay, 200, ScenesTransitions.transitionFinished, Phaser.Easing.Back.Out, btnMenuButtons[i].scale.x);
            if(i == 3)
                ScenesTransitions.showSceneScale(achMenuButtonIndicator, delay, 200, ScenesTransitions.transitionFinished, Phaser.Easing.Back.Out, game.width / 680);
            delay += 100;
        }

        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
    },

    HideAnimated: function()
    {
        ScenesTransitions.transitionStarted();

        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;

        var delay = 0;
        for(var i = 0; i < btnMenuButtons.length; i++){
            ScenesTransitions.hideSceneScale(btnMenuButtons[i], delay, 200, ScenesTransitions.transitionFinished, Phaser.Easing.Back.In);
            if(i == 3)
                ScenesTransitions.hideSceneScale(achMenuButtonIndicator, delay, 200, null, Phaser.Easing.Back.In);
            delay += 100;
        }

        ScenesTransitions.hideSceneAlpha(grpScenePlay, 100, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.hideSceneAlpha(grpSceneMenu, 100, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
    }

}