var SceneOptions = function()
{
    SceneOptions.instance = this;

    this.create();
};

SceneOptions.instance = null;

SceneOptions.prototype = {

    create: function()
    {
        grpSceneOptions = game.add.group();
        grpSceneOptions.name = 'grpSceneOptions';
        this.grpScene = grpSceneOptions;

        imgOptionsBG = grpSceneOptions.create(game.width >> 1, game.height >> 1, 'pak1', 'blank.png');
        imgOptionsBG.width = game.width;
        imgOptionsBG.height = game.height;
        imgOptionsBG.anchor.setTo(0.5, 0.5);
        imgOptionsBG.tint = 0x26631e;
        imgOptionsBG.inputEnabled = true;

        optionItems = [];

        topBarOptions = gameState.CreateCaptionBar(grpSceneOptions, 'MENU_SETTINGS');
        topBarOptions.txtCaption.visible = false;

        optionItems.push(this.CreateOptionsItem('music.png', function(){ //SETTINGS_MUSIC
            soundManager.playSound('menu-click1');
            soundManager.toggleMusic(soundManager.actualMusic);
        }));
        optionItems.push(this.CreateOptionsItem('sound.png', function () { //SETTINGS_SOUNDS
            soundManager.playSound('menu-click1');
            soundManager.toggleSounds();
        }));
        /*
        optionItems.push(this.CreateOptionsItem('SETTINGS_LAS_VEGAS_SCORE', function (active) {
            soundManager.playSound('menu-click1');
            GameData.profile.LasVegasScore = active;
            GameData.Save();
            scnGame.UpdateScoreTxtControl();
        }));
        */
        optionItems.push(this.CreateOptionsItem('righthanded.png', function(active){ //SETTINGS_RIGHT_HANDED
            soundManager.playSound('menu-click1');
            GameData.profile.RightHanded = active;
            GameData.Save();

            SceneGame.instance.onResolutionChange();
        }));

        optionsButtons = [];
        optionsButtons.push(gameState.CreateImgButtonWithText(grpSceneOptions, 'gombik2.png', 'INSTRUCTIONS_TITLE', function(){
            soundManager.playSound('menu-click1');
            SceneInstructions.instance.ShowAnimated();
        }.bind(this)));
        optionsButtons.push(gameState.CreateImgButtonWithText(grpSceneOptions, 'gombik2.png', 'ABOUT', function(){
            soundManager.playSound('menu-click1');
            SceneAbout.instance.ShowAnimated();

            /*
            if(Languages.instance.language == "en")
                Languages.instance.language = "fr";
            else if(Languages.instance.language == "fr")
                Languages.instance.language = "it";
            else if(Languages.instance.language == "it")
                Languages.instance.language = "de";
            else if(Languages.instance.language == "de")
                Languages.instance.language = "es";
            else if(Languages.instance.language == "es")
                Languages.instance.language = "pt";
            else if(Languages.instance.language == "pt")
                Languages.instance.language = "en";

            gameState.updateTexts();
            */
        }));

        optionsButtons[0].visible = false;
        optionsButtons[1].visible = false;

        grpSceneOptions.visible = false;
    },

    CreateOptionsItem: function(str, callback)
    {
        var optionsItemBG = grpSceneOptions.create(game.width >> 1, game.height >> 1, 'pak1', 'blank.png');
        optionsItemBG.anchor.set(0.5);
        optionsItemBG.width = game.width;
        optionsItemBG.height = game.height / 8;
        optionsItemBG.tint = 0x327d30;
        optionsItemBG.inputEnabled = true;
        optionsItemBG.STR = str;

        var itemAnchor = grpSceneOptions.create(0, 0, 'pak1', 'void.png');
        itemAnchor.anchor.set(0.5);
        optionsItemBG.addChild(itemAnchor);

        /*
        var txtCaption = gameState.CreateText(30, -5, 'gamefont', STR(str), 55 * game.width / 680);
        txtCaption.anchor.setTo(0, 0.5);
        txtCaption.tint = 0xffffff;
        itemAnchor.addChild(txtCaption);
        */

        var imgCaption = grpSceneOptions.create(30, -5, 'pak1', str);
        imgCaption.anchor.setTo(0, 0.5);
        itemAnchor.addChild(imgCaption);

        var itemSwitch = grpSceneOptions.create(0, 0, 'pak1', 'opt-on.png');
        itemSwitch.anchor.setTo(1, 0.5);
        itemSwitch.scale.set(game.width / 680 * 0.6);
        itemSwitch.active = true;
        itemAnchor.addChild(itemSwitch);
        itemSwitch.callback = callback;

        AddButtonEvents(itemSwitch, SceneOptions.instance.OnPressedOptionSwitch, ButtonOnInputOver, ButtonOnInputOut);

        optionsItemBG.itemAnchor = itemAnchor;
        optionsItemBG.itemSwitch = itemSwitch;
        optionsItemBG.imgCaption = imgCaption;
        //optionsItemBG.txtCaption = txtCaption;

        return optionsItemBG;
    },

    OnPressedOptionSwitch: function(itemSwitch)
    {
        itemSwitch = itemSwitch || this.button;

        itemSwitch.active = !itemSwitch.active;
        SceneOptions.instance.UpdateItemSwitch(itemSwitch, itemSwitch.active);

        itemSwitch.callback(itemSwitch.active);
    },

    UpdateItemSwitch: function(itemSwitch, active)
    {
        itemSwitch.active = active;
        itemSwitch.frameName = itemSwitch.active ? 'opt-on.png' : 'opt-off.png';
        itemSwitch.cachedTint = -1;
        AddButtonEvents(itemSwitch, SceneOptions.instance.OnPressedOptionSwitch, ButtonOnInputOver, ButtonOnInputOut);

    },

    onResolutionChange: function()
    {
        imgOptionsBG.position.setTo(game.width >> 1, game.height >> 1);
        imgOptionsBG.width = game.width;
        imgOptionsBG.height = game.height;

        var itemGap = 15;
        var itemH =  game.height * 0.1;

        topBarOptions.width = game.width;
        topBarOptions.height = itemH;
        topBarOptions.itemAnchor.scale.setTo(1 / topBarOptions.scale.x, 1 / topBarOptions.scale.y);
        topBarOptions.x = game.width >> 1;
        topBarOptions.y = topBarOptions.height / 2;

        itemH = game.height / 10;

        var posY = topBarOptions.height + itemGap + itemH / 2;

        for(var i = 0; i < optionItems.length; i++){
            optionItems[i].width = game.width;
            optionItems[i].height = itemH;
            optionItems[i].x = game.width >> 1;
            optionItems[i].y = posY;
            optionItems[i].itemAnchor.scale.setTo(1 / optionItems[i].scale.x, 1 / optionItems[i].scale.y);
            //optionItems[i].txtCaption.x = - game.width / 2 + (game.width * 0.05);
            optionItems[i].imgCaption.x = - game.width / 2 + (game.width * 0.05);
            optionItems[i].itemSwitch.x =  game.width / 2 -  (game.width * 0.04);

            posY += itemGap + itemH;
        }

        posY = game.height - imgMenuBar.height - optionsButtons.length * (itemGap + itemH) + itemGap;

        for(var i = 0; i < optionsButtons.length; i++) {
            optionsButtons[i].height  = itemH;
            optionsButtons[i].scale.x = optionsButtons[i].scale.y;
            optionsButtons[i].y = posY;
            optionsButtons[i].txtCaption.scale.setTo(1 / optionsButtons[i].scale.x, 1 / optionsButtons[i].scale.y);
            posY += itemGap + itemH;
        }

        SceneOptions.instance.UpdateItemSwitch(optionItems[0].itemSwitch, soundManager.musicPlaying);
        SceneOptions.instance.UpdateItemSwitch(optionItems[1].itemSwitch, soundManager.soundPlaying);
        //SceneOptions.instance.UpdateItemSwitch(optionItems[2].itemSwitch, GameData.profile.LasVegasScore);
        SceneOptions.instance.UpdateItemSwitch(optionItems[2].itemSwitch, GameData.profile.RightHanded);
    },

    update: function()
    {

    },

    updateTexts: function()
    {
        topBarOptions.txtCaption.text = STR(topBarOptions.STR);

        /*
        for(var i = 0; i < optionItems.length; i ++){
            optionItems[i].txtCaption.text = STR(optionItems[i].STR);
            updateBitmapTextToWidth(optionItems[i].txtCaption, 40 * game.width / 680, game.width * 0.7);
        }
        */

        for(var i = 0; i < optionsButtons.length; i ++)
            optionsButtons[i].txtCaption.text = STR(optionsButtons[i].STR);
    },

    ShowAnimated: function ()
    {
        grpSceneOptions.position.setTo(0, 0);
        SceneOptions.instance.onResolutionChange();

        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Quadratic.Out;
        ScenesTransitions.showSceneAlpha(grpSceneOptions, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
    },

    HideAnimated: function ()
    {
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
        ScenesTransitions.hideSceneAlpha(grpSceneOptions, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);

        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
    }

}


