
var ScenePlay = function()
{
    ScenePlay.instance = this;

    this.create();
};

ScenePlay.instance = null;

ScenePlay.prototype = {

    create: function ()
    {
        grpScenePlay = game.add.group();
        grpScenePlay.name = "grpScenePlay";
        this.grpScene = grpScenePlay;

        imgPlayBG = grpScenePlay.create(game.width >> 1, game.height >> 1, 'pak1', 'blank.png');
        imgPlayBG.width = game.width;
        imgPlayBG.height = game.height;
        imgPlayBG.anchor.setTo(0.5, 0.5);
        imgPlayBG.tint = 0x26631e;
        
        imgPlayLogo = game.add.sprite((game.width >> 1), (game.height >> 1) * 0.3, 'pak1', 'logo.png');
        imgPlayLogo.anchor.set(0.5);
        imgPlayLogo.scale.set(game.width / 680);
        grpScenePlay.add(imgPlayLogo);

        btnPlayGlow1 = game.add.sprite((game.width >> 1), (game.height >> 1), 'pak1', 'play2.png');
        btnPlayGlow1.blendMode = PIXI.blendModes.ADD;
        btnPlayGlow1.alpha = 0.7;
        btnPlayGlow1.anchor.set(0.5);
        btnPlayGlow1.scale.set(game.width / 680 * 0.6);
        grpScenePlay.add(btnPlayGlow1);

        btnPlayGlow2 = game.add.sprite((game.width >> 1), (game.height >> 1), 'pak1', 'play2.png');
        btnPlayGlow2.blendMode = PIXI.blendModes.ADD;
        btnPlayGlow2.alpha = 0.7;
        btnPlayGlow2.anchor.set(0.5);
        btnPlayGlow2.scale.set(game.width / 680 * 0.6);
        grpScenePlay.add(btnPlayGlow2);

        btnPlayGlow1.twnScale = game.add.tween(btnPlayGlow1.scale).to({x: 0.9, y :0.9}, ScenesTransitions.TRANSITION_LENGTH * 6, Phaser.Easing.Linear.In, false, 0, -1);
        btnPlayGlow1.twnAlpha = game.add.tween(btnPlayGlow1).to({alpha: 0}, ScenesTransitions.TRANSITION_LENGTH * 6, Phaser.Easing.Linear.In, false, 0, -1);

        btnPlayGlow2.twnScale = game.add.tween(btnPlayGlow2.scale).to({x: 0.9, y :0.9}, ScenesTransitions.TRANSITION_LENGTH * 6, Phaser.Easing.Linear.In, false, ScenesTransitions.TRANSITION_LENGTH * 3, -1);
        btnPlayGlow2.twnAlpha = game.add.tween(btnPlayGlow2).to({alpha: 0}, ScenesTransitions.TRANSITION_LENGTH * 6, Phaser.Easing.Linear.In, false, ScenesTransitions.TRANSITION_LENGTH * 3, -1);

        btnPlayPlay = game.add.sprite((game.width >> 1), (game.height >> 1), 'pak1', 'play2.png');
        btnPlayPlay.anchor.set(0.5);
        btnPlayPlay.scale.set(game.width / 680 * 0.6);
        grpScenePlay.add(btnPlayPlay);
        AddButtonEvents(btnPlayPlay, ScenePlay.instance.OnPressedPlay, ButtonOnInputOver, ButtonOnInputOut);

        imgPlayDrawOff = game.add.sprite((game.width >> 1), (game.height >> 1) * 0.7, 'pak1', 'drawoff.png');
        imgPlayDrawOff.anchor.set(0.5);
        imgPlayDrawOff.scale.set(game.width / 680 * 0.6);
        grpScenePlay.add(imgPlayDrawOff);

        imgPlayDraw1 = game.add.sprite(0, 0, 'pak1', 'draw1.png');
        imgPlayDraw1.anchor.setTo(1, 0.5);
        imgPlayDrawOff.addChild(imgPlayDraw1);

        imgPlayDraw3 = game.add.sprite(0, 0, 'pak1', 'draw3.png');
        imgPlayDraw3.anchor.setTo(0, 0.5);
        imgPlayDrawOff.addChild(imgPlayDraw3);
        imgPlayDraw3.visible = false;

        btnPlayDraw = game.add.sprite(0, 0, 'pak1', 'void.png');
        btnPlayDraw.anchor.setTo(0.5, 0.5);
        btnPlayDraw.width = imgPlayDrawOff.width / imgPlayDrawOff.scale.x;
        btnPlayDraw.height = imgPlayDrawOff.height / imgPlayDrawOff.scale.y;
        imgPlayDrawOff.addChild(btnPlayDraw);
        AddButtonEvents(btnPlayDraw, ScenePlay.instance.OnPressedPlayDraw, ButtonOnInputOver, ButtonOnInputOut);

        btnPlayQuit = game.add.sprite(game.width >> 1, game.height >> 1, 'pak1', 'quit.png');
        btnPlayQuit.anchor.setTo(0.5, 0.5);
        btnPlayQuit.scale.set(game.width / 680 * 0.7);
        AddButtonEvents(btnPlayQuit, function(){
            soundManager.playSound('menu-click1');
            /*gameRunning = true;
             ScenePause.instance.HideAnimated();
             SceneMenu.instance.HideAnimated();*/
            SceneMenu.instance.QuitGame();
        }, ButtonOnInputOver, ButtonOnInputOut);
        grpScenePlay.addChild(btnPlayQuit);
        btnPlayQuit.visible = (game.device.cocoonJS);

        grpScenePlay.visible = false;
    },

    OnPressedPlayDraw: function()
    {
        soundManager.playSound('menu-click1');

        if(game.input.x < game.width >> 1){
            imgPlayDraw1.visible = true;
            imgPlayDraw3.visible = false;
        }else{
            imgPlayDraw1.visible = false;
            imgPlayDraw3.visible = true;
        }

        GameData.profile.Draw1 = imgPlayDraw1.visible;
        GameData.Save();
    },

    OnPressedPlay: function()
    {
        SceneGame.instance.onResolutionChange();
        SceneGame.instance.ResetGame();

        ScenePlay.instance.HideAnimated();
        SceneMenu.instance.HideAnimated();
        SceneGame.instance.ShowAnimated();
    },

    onResolutionChange: function()
    {
        ScenePlay.instance.RestartGlowTweens();

        imgPlayDraw1.visible = GameData.profile.Draw1;
        imgPlayDraw3.visible = !GameData.profile.Draw1;

        imgPlayBG.position.setTo(game.width >> 1, game.height >> 1);
        imgPlayBG.width = game.width;
        imgPlayBG.height = game.height;
        
        imgPlayLogo.position.setTo((game.width >> 1), (game.height >> 1) * 0.4);
        btnPlayGlow1.position.setTo((game.width >> 1), (game.height >> 1));
        btnPlayGlow2.position.setTo((game.width >> 1), (game.height >> 1));
        btnPlayPlay.position.setTo((game.width >> 1), (game.height >> 1));
        imgPlayDrawOff.position.setTo((game.width >> 1), (game.height >> 1) * 1.45);

        btnPlayQuit.position.setTo(game.width - btnPlayQuit.width * 0.8, btnPlayQuit.width * 0.8);
    },

    RestartGlowTweens: function()
    {
        btnPlayGlow1.twnAlpha.stop();
        btnPlayGlow1.twnScale.stop();
        btnPlayGlow2.twnAlpha.stop();
        btnPlayGlow2.twnScale.stop();

        game.tweens.removeFrom(btnPlayGlow1, true);
        game.tweens.removeFrom(btnPlayGlow2, true);

        btnPlayGlow1.alpha = 0.7;
        btnPlayGlow1.scale.set(game.width / 680 * 0.6);

        btnPlayGlow2.alpha = 0.7;
        btnPlayGlow2.scale.set(game.width / 680 * 0.6);

        btnPlayGlow1.twnScale = game.add.tween(btnPlayGlow1.scale).to({x: game.width / 680 * 0.9, y :game.width / 680 * 0.9}, ScenesTransitions.TRANSITION_LENGTH / 0.18, Phaser.Easing.Linear.In, true, 0, -1);
        btnPlayGlow1.twnAlpha = game.add.tween(btnPlayGlow1).to({alpha: 0}, ScenesTransitions.TRANSITION_LENGTH / 0.18, Phaser.Easing.Linear.In, true, 0, -1);

        btnPlayGlow2.twnScale = game.add.tween(btnPlayGlow2.scale).to({x: game.width / 680 * 0.9, y :game.width / 680 * 0.9}, ScenesTransitions.TRANSITION_LENGTH / 0.18, Phaser.Easing.Linear.In, true, ScenesTransitions.TRANSITION_LENGTH / 0.36, -1);
        btnPlayGlow2.twnAlpha = game.add.tween(btnPlayGlow2).to({alpha: 0}, ScenesTransitions.TRANSITION_LENGTH / 0.18, Phaser.Easing.Linear.In, true, ScenesTransitions.TRANSITION_LENGTH / 0.36, -1);

    },

    update: function()
    {
    },

    updateTexts: function()
    {
    },

    HideAnimated: function ()
    {
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
        ScenesTransitions.hideSceneAlpha(grpScenePlay, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
    }

}