var SceneThemes = function()
{
    SceneThemes.instance = this;

    this.create();
};

SceneThemes.instance = null;

SceneThemes.prototype = {

    create: function()
    {
        grpSceneThemes = game.add.group();
        grpSceneThemes.name = 'grpSceneThemes';
        this.grpScene = grpSceneThemes;

        imgThemesBG = grpSceneThemes.create(game.width >> 1, game.height >> 1, 'pak1', 'blank.png');
        imgThemesBG.width = game.width;
        imgThemesBG.height = game.height;
        imgThemesBG.anchor.setTo(0.5, 0.5);
        imgThemesBG.tint = 0x26631e;
        imgThemesBG.inputEnabled = true;
        
        themesItems = [];

        topBarThemes = gameState.CreateCaptionBar(grpSceneThemes, 'MENU_THEMES');
        topBarThemes.txtCaption.visible = false;

        imgThemesCoinsHolder = gameState.CreateCoinsHolder(grpSceneThemes, topBarThemes);

        themesItems.push(this.CreateThemesItem('THEMES_CARD_FACES', ['tk1.png', 'tk2.png', 'tk3.png'], ['sipka-lava.png', 'sipka-prava.png'], 'CardFaces', 'UsedCardFace'));
        themesItems.push(this.CreateThemesItem('THEMES_BACKS', ['tb1.png', 'tb2.png', 'tb3.png', 'tb4.png', 'tb5.png'], ['sipka-lava.png', 'sipka-prava.png'], 'CardBacks', 'UsedCardBack'));
        themesItems.push(this.CreateThemesItem('THEMES_BACKGROUND', ['vyberbg1.png', 'vyberbg2.png', 'vyberbg3.png', 'vyberbg4.png', 'vyberbg5.png', 'vyberbg6.png', 'vyberbg7.png', 'vyberbg8.png'], ['sipka-tm-lava.png', 'sipka-tm-prava.png'], 'Backgrounds', 'UsedBackground'));

        grpSceneThemes.visible = false;
    },

    CreateThemesItem: function(str, imgs, arrows, profileItems, selectedProfileItem)
    {
        var themesItemBG = grpSceneThemes.create(game.width >> 1, game.height >> 1, 'pak1', 'blank.png');
        themesItemBG.anchor.set(0.5);
        themesItemBG.width = game.width;
        themesItemBG.height = game.height / 8;
        themesItemBG.tint = 0x327d30;
        themesItemBG.inputEnabled = true;
        themesItemBG.imgs = imgs;
        themesItemBG.activeImgIdx = 0;
        themesItemBG.profileItems = profileItems;
        themesItemBG.selectedProfileItem = selectedProfileItem;
        themesItemBG.STR = str;

        var itemAnchor = grpSceneThemes.create(0, 0, 'pak1', 'void.png');
        itemAnchor.anchor.set(0.5);
        themesItemBG.addChild(itemAnchor);

        var itemImg = grpSceneThemes.create(0, 0, 'pak1', imgs[0]);
        itemImg.anchor.setTo(0.5, 0.5);
        itemImg.scale.set(0.7 * game.width / 680);
        itemAnchor.addChild(itemImg);

        var txtCaption = gameState.CreateText(30, 0, 'gamefont', STR(str), 30 * game.width / 680);
        txtCaption.anchor.setTo(0, 0.5);
        txtCaption.tint = 0x9ed0ed;
        txtCaption.visible = false;
        itemAnchor.addChild(txtCaption);

        var itemArrowLeft = grpSceneThemes.create(0, 0, 'pak1', arrows[0]);
        itemArrowLeft.anchor.setTo(0.5, 0.5);
        itemArrowLeft.scale.set(game.width / 680 * 0.5);
        itemAnchor.addChild(itemArrowLeft);
        AddButtonEvents(itemArrowLeft, SceneThemes.instance.PrevImg, ButtonOnInputOver, ButtonOnInputOut);

        var itemArrowRight = grpSceneThemes.create(0, 0, 'pak1', arrows[1]);
        itemArrowRight.anchor.setTo(0.5, 0.5);
        itemArrowRight.scale.set(game.width / 680 * 0.5);
        itemAnchor.addChild(itemArrowRight);
        AddButtonEvents(itemArrowRight, SceneThemes.instance.NextImg, ButtonOnInputOver, ButtonOnInputOut);

        var itemButtonUse = grpSceneThemes.create(0, 0, 'pak1', 'smallbutton.png');
        itemButtonUse.anchor.setTo(0.5, 0.5);
        itemButtonUse.scale.set(game.width / 680 * 0.7);
        itemAnchor.addChild(itemButtonUse);
        AddButtonEvents(itemButtonUse, SceneThemes.instance.UseSelectedItem, ButtonOnInputOver, ButtonOnInputOut);

        /*
        var txtUse = gameState.CreateText(0, -5, 'gamefont', 'Use', 38);
        txtUse.anchor.setTo(0.5, 0.5);
        txtUse.tint = 0xffffff;
        txtUse.align = 'center';
        itemButtonUse.addChild(txtUse);
        */
        var imgUse = grpSceneThemes.create(0, 0, 'pak1', 'markdone.png');
        imgUse.anchor.setTo(0.5, 0.5);
        itemButtonUse.addChild(imgUse);

        var itemCoin = grpSceneThemes.create(40, 0, 'pak1', 'mincaB.png');
        itemCoin.anchor.setTo(0.5, 0.5);
        itemCoin.scale.set(0.5);
        itemButtonUse.addChild(itemCoin);

        var txtPrice = gameState.CreateText(-5, -5, 'gamefont', '250', 38);
        txtPrice.anchor.setTo(1, 0.5);
        txtPrice.tint = 0xffffff;
        itemButtonUse.addChild(txtPrice);

        themesItemBG.itemAnchor = itemAnchor;
        themesItemBG.itemImg = itemImg;
        themesItemBG.txtCaption = txtCaption;
        themesItemBG.itemArrowLeft = itemArrowLeft;
        themesItemBG.itemArrowRight = itemArrowRight;
        themesItemBG.itemButtonUse = itemButtonUse;
        //themesItemBG.txtUse = txtUse;
        themesItemBG.imgUse = imgUse;
        themesItemBG.txtPrice = txtPrice;
        themesItemBG.itemCoin = itemCoin;

        return themesItemBG;
    },

    PrevImg: function()
    {
        soundManager.playSound('menu-click1');

        var duration = ScenesTransitions.TRANSITION_LENGTH / 2;
        var item = this.button.parent.parent;
        var itemImg = item.itemImg;

        ScenesTransitions.transitionStarted();

        var tweenAlpha = game.add.tween(itemImg).to({alpha: 0}, duration * 0.8, Phaser.Easing.Linear.In, true);
        var tweenPosition = game.add.tween(itemImg.position).to({x : -game.width >> 1}, duration, Phaser.Easing.Linear.In, true);
        tweenPosition.onComplete.add(function(){
            this.item.activeImgIdx --;
            if(this.item.activeImgIdx < 0)
                this.item.activeImgIdx += this.item.imgs.length;

            this.itemImg.frameName = this.item.imgs[this.item.activeImgIdx];

            if(this.itemImg.frameName.indexOf('vyberbg') != -1){
                this.itemImg.width = game.width;
                this.itemImg.height = this.itemImg.parent.parent.height;
            }

            this.itemImg.position.x = game.width >> 1;
            var tweenAlpha = game.add.tween(itemImg).to({alpha: 1}, duration * 0.8, Phaser.Easing.Linear.In, true);
            var tweenPosition = game.add.tween(itemImg.position).to({x : 0}, duration, Phaser.Easing.Linear.In, true);

            tweenPosition.onComplete.add(function(){
                SceneThemes.instance.UpdateUseButton(this.item);
                ScenesTransitions.transitionFinished();
            }, {item: this.item});
        }, {item: item, itemImg: itemImg});

        SceneThemes.instance.UpdateUseButton(item);
    },

    NextImg: function()
    {
        soundManager.playSound('menu-click1');

        var duration = ScenesTransitions.TRANSITION_LENGTH / 2;
        var item = this.button.parent.parent;
        var itemImg = item.itemImg;

        ScenesTransitions.transitionStarted();

        var tweenAlpha = game.add.tween(itemImg).to({alpha: 0}, duration * 0.8, Phaser.Easing.Linear.In, true);
        var tweenPosition = game.add.tween(itemImg.position).to({x : game.width >> 1}, duration, Phaser.Easing.Linear.In, true);
        tweenPosition.onComplete.add(function(){
            this.item.activeImgIdx ++;
            if(this.item.activeImgIdx >= this.item.imgs.length)
                this.item.activeImgIdx -= this.item.imgs.length;

            this.itemImg.frameName = this.item.imgs[this.item.activeImgIdx];
            if(this.itemImg.frameName.indexOf('vyberbg') != -1){
                this.itemImg.width = game.width;
                this.itemImg.height = this.itemImg.parent.parent.height;
            }
            this.itemImg.position.x = -game.width >> 1;

            var tweenAlpha = game.add.tween(itemImg).to({alpha: 1}, duration * 0.8, Phaser.Easing.Linear.In, true);
            var tweenPosition = game.add.tween(itemImg.position).to({x : 0}, duration, Phaser.Easing.Linear.In, true);

            tweenPosition.onComplete.add(function(){
                SceneThemes.instance.UpdateUseButton(this.item);
                ScenesTransitions.transitionFinished();
            }, {item: this.item});

        }, {item: item, itemImg: itemImg});

    },

    UpdateUseButton: function (item)
    {
        var owned = GameData.profile[item.profileItems][item.activeImgIdx] == 0;
        var used = item.activeImgIdx == GameData.profile[item.selectedProfileItem];
        //item.txtUse.visible = owned;
        //item.txtUse.text = used ? STR('THEMES_IN_USE') : STR('THEMES_USE');
        item.imgUse.visible = owned;
        item.imgUse.frameName = used ? 'themeinuse.png' : 'themeuse.png';
        //item.imgUse.text = used ? STR('THEMES_IN_USE') : STR('THEMES_USE');
        item.itemButtonUse.tint = used ? 0x1b7fa5 : 0xffffff;
        item.txtPrice.text = '' + GameData.profile[item.profileItems][item.activeImgIdx];
        item.txtPrice.visible = !owned;
        item.itemCoin.visible = !owned;

        //updateBitmapTextToWidth(item.txtUse, 38, item.itemButtonUse.width * 0.9);
    },

    UseSelectedItem: function()
    {
        soundManager.playSound('menu-click1');

        var item = this.button.parent.parent;
        var price = GameData.profile[item.profileItems][item.activeImgIdx];

        if(price == 0){
            GameData.profile[item.selectedProfileItem] = item.activeImgIdx;
            SceneThemes.instance.UpdateUseButton(item);
            SceneThemes.instance.UpdateSelectedItems(item.profileItems);
            GameData.Save();
            return;
        }

        if(GameData.profile.PlayerCoins < price)
            return;

        GameData.profile[item.profileItems][item.activeImgIdx] = 0;
        GameData.profile.PlayerCoins -= price;
        GameData.profile[item.selectedProfileItem] = item.activeImgIdx;
        GameData.Save();

        imgThemesCoinsHolder.txtPrice.text = '' + GameData.profile.PlayerCoins;
        updateBitmapTextToWidth(imgThemesCoinsHolder.txtPrice, 38, 100);

        SceneThemes.instance.UpdateUseButton(item);
        SceneThemes.instance.UpdateSelectedItems(item.profileItems);
    },

    UpdateSelectedItems: function(items)
    {
        if(items == 'Backgrounds'){
            SceneGameOver.instance.onResolutionChange();
            SceneGame.instance.onResolutionChange();
        }

        if(items == 'CardBacks'){
            SceneGameOver.instance.ReloadCardBacks();
            SceneGame.instance.ReloadCardBacks();
        }

        if(items == 'CardFaces'){
            SceneGameOver.instance.ReloadCardFaces();
            SceneGame.instance.ReloadCardFaces();
        }

    },

    onResolutionChange: function()
    {
        imgThemesCoinsHolder.txtPrice.text = '' + GameData.profile.PlayerCoins;
        updateBitmapTextToWidth(imgThemesCoinsHolder.txtPrice, 38, 100);

        imgThemesBG.position.setTo(game.width >> 1, game.height >> 1);
        imgThemesBG.width = game.width;
        imgThemesBG.height = game.height;

        var itemGap = 15;
        var itemH = game.height * 0.1;

        topBarThemes.width = game.width;
        topBarThemes.height = itemH;
        topBarThemes.itemAnchor.scale.setTo(1 / topBarThemes.scale.x, 1 / topBarThemes.scale.y);
        topBarThemes.y = topBarThemes.height / 2;
        topBarThemes.x = game.width >> 1;

        var idx = themesItems.length - 1;
        themesItems[idx].itemImg.width = game.width;
        themesItems[idx].itemImg.scale.y = themesItems[idx].itemImg.scale.x;
        while(themesItems[idx].itemImg.height > game.height * 0.21)
            themesItems[idx].itemImg.scale.y -= 0.05;
        itemH = themesItems[idx].itemImg.height;

        var posY = topBarThemes.height + itemH / 2 + itemGap;

        for(var i = 0; i < themesItems.length; i++){
            themesItems[i].width = game.width;
            themesItems[i].height = itemH;

            if(i < themesItems.length - 1){
                themesItems[i].itemImg.height = itemH * 0.8;
                themesItems[i].itemImg.scale.x = themesItems[i].itemImg.scale.y;
            }

            themesItems[i].y = posY;
            themesItems[i].itemAnchor.scale.setTo(1 / themesItems[i].scale.x, 1 / themesItems[i].scale.y);
            themesItems[i].txtCaption.x = -game.width / 2 + 30;// + game.width * 0.44;
            themesItems[i].txtCaption.y = - themesItems[i].height * 0.4;// + game.width * 0.44;
            themesItems[i].itemArrowLeft.x = - themesItems[i].width / 8 * 3;
            themesItems[i].itemArrowRight.x =  themesItems[i].width / 8 * 3;
            themesItems[i].itemButtonUse.x =  themesItems[i].width / 8 * 3;
            themesItems[i].itemButtonUse.y =  themesItems[i].height / 2 * 0.6;
            themesItems[i].txtCaption.alpha = 0;

            SceneThemes.instance.UpdateUseButton(themesItems[i]);

            posY += itemGap + itemH;
        }
    },

    update: function()
    {

    },

    updateTexts: function()
    {
        topBarThemes.txtCaption.text = STR(topBarThemes.STR);

        for(var i = 0; i < themesItems.length; i++) {
            themesItems[i].txtCaption.text = STR(themesItems[i].STR);
            //updateBitmapTextToWidth(themesItems[i].txtCaption, 35, game.width * 0.3);
        }
    },

    ShowAnimated: function ()
    {
        grpSceneThemes.position.setTo(0, 0);
        SceneThemes.instance.onResolutionChange();

        ScenesTransitions.transitionStarted();
        SceneThemes.instance.UpdateLanguageButtons();
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Quadratic.Out;
        ScenesTransitions.showSceneAlpha(grpSceneThemes, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
    },

    HideAnimated: function ()
    {
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
        ScenesTransitions.hideSceneAlpha(grpSceneThemes, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);

        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
    }

}


