/**
 * Created by echovanec on 10. 12. 2014.
 */

/** @constructor */
var Splash = function(game){};


Splash.prototype = {
    preload: function(){
        game = this.game;

        loadSplash(this.game);
    },

    create: function()
    {
        this.game.stage.backgroundColor = 0x26631e;
        this.game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
        this.game.scale.setShowAll();
        this.game.scale.pageAlignHorizontally = true;
        this.game.scale.pageAlignVertically = true;

        this.game.scale.parentScaleFactor = new Phaser.Point(3, 3);
        this.game.scale.refresh();
        this.game.canvas.screencanvas = false;
        this.game.clearBeforeRender = false;
        LOG(JSON.stringify(document.style));

        this.logo = this.add.sprite(this.game.world.centerX, 0, 'inlogic_logo');
        this.logo.anchor.setTo(0.5, 0);
        this.logo.alpha = 1;
        this.loadContinue();
    },

    loadContinue: function ()
    {
        this.logo.inputEnabled = true;
        this.logo.events.onInputDown.add(this.startPreload, this);
        this.startPreload();
    },

    hideLogo: function () {
        game.add.tween(this.logo).to( { alpha : 0 }, ScenesTransitions.TRANSITION_LENGTH * 3, ANIMATION_CUBIC_IO, true, 0, 0, false);
    },

    startPreload: function()
    {
        analyticsOnGameStartEvent();
        this.game.state.start("PreloadState");
    }

};
